	LEGEND "Critical error handler demonstration"
	ON ESCAPE GOSUB Exit		; Catch escapes
;
; ----- Demonstrate critical error replacement overlay
;	commenced: 3/16/93 R.McG
; ----------------------------------------------------------------
;	Note: This script loads the CRITERR overlay to intercept DOS's
;	"abort, retry, fail" errors when a diskette in not in a drive
;	and a script wants to access that drive.
;
;	The CRITERR overlay should *always* be unloaded when it is not
;	needed.  COM-AND's own critical error handler is sufficient in
;	most cases...
; ----------------------------------------------------------------
;
;	Set-up the overlay
;
	OVERLAY "CRITERR.EXE" 6         ; Load our overlay w/end entry point
	IF FAILED			; Stop here if can't load overlay
	   MESS "Overlay failed to load"
	   EXIT
	   ENDIF
;
;	Invoke the overlay to take the critical error vector
;
	SCALL 0,N0			; Rtn one parameter
	IF ZERO N0			; Stop here if can't load overlay
	   MESS "Overlay failed to initialize - DOS version error"
	   EXIT
	   ENDIF
;
;	Put up a warning to insert a diskette in drive a:
;
Loop:
	WOPEN 10,5 ,12,75 (defa)	; Open a window
	ATSAY 11,7  (defa) " Insert a diskette in drive a:..."
	ATSAY 12,22 (defa) " Press any key to continue "
	KEYGET S0			; Wait for any key
	WCLOSE				; Drop open window
;
;	Look for some file on "A:"
;
	FFIRST "a:*.*"
	IF FAILED			; No files found... maybe
	   SCALL 3,N0			; Ask if crit error flag was invoked
	   IF ZERO N0			; Report no files found
	      MESS "No files found"
	      GOTO Exit
	      ENDIF
	   WOPEN 10,5 ,12,75 (defa)	; Open a window
	   ATSAY 11,7  (defa) " No disk in drive, or unformatted diskette..."
	   ATSAY 12,22 (defa) " Press any key to continue "
	   KEYGET S0			; Wait for any key
	   WCLOSE			; Drop open window
	   SCAL 0,N0			; Reset the flag we query here
	   GOTO Loop
	   ENDIF
;
;	Report at least one file found
;
	MESS "At least one file found..."
;
;	Clear the overlay (automatically invokes entry point 6, as that
;	.. entry point was specified as end-entry when the overlay loaded.
;
Exit:
	OVERLAY CLEAR
	EXIT
