		page	55, 131
		subttl	IBM-PC
		title	overlay module for IBM-PC
		name	overlay

;************************************************
;*						*
;*	NAPLPS decoder program			*
;*		overlay module			*
;*						*
;*	ibmpc	ver 1.00  06-Feb-1988  by Komai *
;*						*
;************************************************

		if1
		%out	*** pass one ***
		endif
		if2
		%out	*** pass two ***
		endif

		.287
_TEXT		segment	byte public 'CODE'
_TEXT		ends
		assume	cs:_TEXT, ds:nothing, es:nothing, ss:nothing

;	Constant definition

CheckNum	equ	415Eh

IntNap		=	0EFh
bdos		=	21h

true		=	-1
false		=	0

nega		=	false
rev		=	false

dots		=	640
lines		=	200

X		=	4		; offset of arguments

CR		=	0dh
LF		=	0ah
ESC		=	1bh
EOS		=	'$'

GVRAM		=	0B800H

;	Structure Definition

syspara		struc
at		dw	?		;; Dot Ratio Horizontal/Vertical
xdot		dw	?		;; Horizontal Dot
ydot		dw	?		;; Vertical Dot
Sx		dw	?		;; View location X ( x 8192)
Sy		dw	?		;; View location Y ( x 8192)
Wx		dw	?		;; View width X    ( x 8192)
Wy		dw	?		;; View width Y    ( x 8192)
knjX		dw	?		;; Kanji font size X
knjY		dw	?		;; Kanji font size Y
wait		dw	?		;; wait loop
syspara		ends

;	Macro Definition

pushall		macro
		irp	reg, <ax,bx,cx,dx,si,di,ds,es>
		push	reg
		endm
		endm

popall		macro
		irp	reg, <es,ds,di,si,dx,cx,bx,ax>
		pop	reg
		endm
		endm

saveint		macro	number, buffer
		push	es
		mov	ax, 3500h + number	;; Get Interrupt vector
		int	bdos			;;   (ES:BX)
		mov	word ptr [buffer], bx	;; save to buffer
		mov	word ptr [buffer+2], es
		pop	es
		endm

setint		macro	number, address
		push	ds
		push	cs
		pop	ds
		mov	dx, address		;; Set Interrupt vector
		mov	ax, 2500h + number	;;   (DS:DX)
		int	bdos
		pop	ds
		endm

resint		macro	number, buffer
		push	ds
		lds	dx, [buffer]
		mov	ax, 2500h + number
		int	bdos
		pop	ds
		endm

;
;	Module Body
;

		assume	cs:_TEXT, ds:nothing, es:nothing
_TEXT		segment


;;	 Module Header

ofs		=	10h
		org	ofs

_startup:	jmp	startup
_endof:		jmp	endof
_gphinit:	jmp	gphinit
_gphon:		jmp	gphon
_gphoff:	jmp	gphoff
_msgout:	jmp	msgout
_getkanji:	jmp	getkanji
_boxfill:	jmp	boxfill
_setmap:	jmp	setmap

;
;	Work Area
;
MsgData		db	'overlay module for IBM-PC (CGA)',CR,LF
		db	'ver3.01    17-Feb-1988  by Komai',CR,LF,'$'
colormapg	db	16 dup( ?)	; color map green
colormapr	db	16 dup( ?)	; color map red
colormapb	db	16 dup( ?)	; color map blue
save_kbvec	dd	?		; Keyboard Bios vector save area
save_Sflag	dd	?		; Far Pointer of Break flag
mode		dw	?		; Resident mode flag
colflg		db	false		; Color mode (Color / BW)

negaflg		db	false
grphflg		db	false		; Graphic ON/OFF
videomode	db	?


		assume	ds:nothing, es:nothing, ss:nothing

msgout:
		push	bp
		push	ds
		push	cs
		pop	ds
		lea	dx, [MsgData]
		mov	ah, 9
		int	bdos
		pop	ds
		pop	bp
		ret

;**
;**	Start Up routine
;**
;**	int ver = _startup( mode, bitflag);
;**
;**	int ver   ... Version number(AX)
;**	int mode  ... -1 : Resident
;**	int *bitflag  ... Pointer of Overlay module type
;**
startup:
		push	bp
		mov	bp, sp
		mov	ax, [bp+4]
		mov	[mode], ax
		cmp	ax, 0			;  0 : No Resident
		jz	start_s
		cmp	ax, -1			; -1 : Resident
		jnz	start_exit
						;; Set resident mode
		saveint	16h, save_kbvec
		setint	16h, <offset intcpt_kbint>
		jmp	start_n

start_s:
start_n:
		mov	bx, [bp+6]
		mov	ax, 0111b		; bit 0 Verson 3.xx
						; bit 1 Use setmap
						; bit 2 Resident in Memory
						; bit 3 Use getkanji
		mov	[bx], ax
		mov	ax, 300h		; 'Ver 3.00'
start_exit:	pop	bp
		ret

;**
;**	End of Program routine
;**
;**	void _endof( flag);
;**
;**	int flag   ...  No resident mode
;**			-1 : Normal end
;**			 0 : Abort
;**
endof:
		push	bp
		mov	bp, sp
		cmp	[mode], -1
		je	endof3
		cmp	word ptr [bp+4], 0
		jz	endof1
		mov	ah, 6			; beep
		mov	dl, 7
		int	bdos
endof2:		mov	ah, 8			; Hit <CR> ?
		int	bdos
		cmp	al, 0Dh
		jnz	endof2
endof1:		call	gphoff
		jmp	endof4
endof3:
		resint	16h, save_kbvec
endof4:		pop	bp
		ret

intcpt_kbint	proc	far
		or	ah,ah
		jz	int_kb3
		jmp	[save_kbvec]
int_kb3:
		pushf
		call	[save_kbvec]
		pushf
		cmp	ax,119*100h		; [Ctrl]+[Home]
		jnz	int_kb0
		push	ax
		push	bx
		push	cx
		push	dx
		push	si
		push	di
		push	ds
		push	es
		cmp	[grphflg],false
		jnz	int_kb1
		call	gphon
		jmp	short int_kb2
;
int_kb1:	call	gphoff
int_kb2:
		pop	es
		pop	ds
		pop	di
		pop	si
		pop	dx
		pop	cx
		pop	bx
		pop	ax

int_kb0:
		popf
		ret	2
intcpt_kbint	endp

;**
;**	Graph Initialize routine
;**
;**	void _gphinit( nflag, &para, &sflag);
;**
;**	int nflag;  ... Option value '-N#'
;**			default 0
;**	struct syspara *para;
;**		    ... Pointer of Structured Parameter
;**	int *sflag; ... Pointer of break flag (sflag)
;**
gphinit:
		push	bp
		mov	bp, sp
		cmp	word ptr [bp+4],-1
		jnz	gphinit3
		mov	word ptr [bp+4], 2
gphinit3:
		mov	bx, [bp+6]
		mov	[bx].Sx, 819		; 0.1 x 8192
		mov	[bx].Sy, 0		; 0.0
		mov	[bx].Wx, 6553		; 0.8 x 8192
		mov	[bx].Wy, 8192		; 1.0 x 8192
		mov	[bx].knjX, 16
		mov	[bx].knjY, -20
		mov	[bx].at, -16384/2	; -1.0  x 16384 / 2
		test	word ptr [bp+4],4
		jz	gphinit30
		mov	[bx].at, -13926/2	; -0.85 x 16384 / 2
		mov	[bx].Sx, 256		; 0.03125 x 8192
		mov	[bx].Wx, 7680		; 0.9375  x 8192
gphinit30:
		mov	[bx].xdot, dots
		mov	[bx].ydot, 200
		test	word ptr [bp+4],2
		jnz	gphinit1
		shl	[bx].at, 1
		mov	[bx].xdot, dots/2
		mov	[colflg], true
gphinit1:
		test	word ptr [bp+4], 1
		jz	gphinit2
		mov	[negaflg], true

gphinit2:
		cmp	[mode], -1		;; Resident = -1
		je	gphinit_exit
		mov	ax, [bp+8]		; Sflag
		mov	word ptr [save_Sflag], ax
		mov	word ptr [save_Sflag+2], ds
		setint	23h, <offset entry_STOP>
gphinit_exit:	pop	bp
		ret

		assume	ds:nothing, es:nothing, ss:nothing
entry_STOP:
		push	ds
		push	bx
		lds	bx, [save_Sflag]
		mov	word ptr [bx], -1
		pop	bx
		pop	ds
		iret

		assume	ds:nothing, es:nothing, ss:nothing
;**
;**	Graphic Screen On routine
;**
;**	void gphon();
;**
gphon:
		cmp	[grphflg],false
		jnz	gphon1
		mov	[grphflg],true
		mov	ah,15		; Get Current Video state
		int	10h
		mov	[videomode],al
		mov	ax,0006h
		test	[colflg],0ffh
		jz	gphon2
		mov	ax,0005h
		test	[negaflg],0ffh
		jz	gphon3
		mov	ax,0004h
gphon3:
		int	10h
		mov	ah,11
		mov	bx,101h		; Select Palette Cyan/Magenta/WHite
		int	10h
		mov	ah,11
		mov	bx,000h		; Select the background color
gphon2:
		int	10h
gphon1:
		ret
;**
;**	Graphic Screen Off routine
;**
;**	void gphoff();
;**
gphoff:
		cmp	[grphflg],false
		jz	gphon1
		mov	[grphflg], false
		sub	ah,ah
		mov	al,[videomode]
		int	10h
		ret

;**
;**	void getkanji( font, code);
;**
;**	char	font[][]; ... font buffer
;**	int	code;	  ... Kanji Code (JIS)
;**
; GETKANJI	Get Kanji Font ( 16 x 20 )
getkanji:
		ret

;**
;**	Set Color to Map Addres
;**
;**	void setmap( adrs, green, red, blue);
;**
;**	int adrs;  ...  Color map address
;**	int green; ...  Color value
;**	int red;   ...  Color value
;**	int blue;  ...  Color value
;**
setmap:
		assume	ds:nothing, es:nothing, ss:nothing
		push	bp
		mov	bp, sp
		mov	bx, [bp+X]	; address
		mov	cl,5
		mov	ax, [bp+X+6]	; color blue
		shr	ah,cl
		mov	colormapb[bx], ah
		mov	ax, [bp+X+4]	; color red
		shr	ah,cl
		mov	colormapr[bx], ah
		mov	ax, [bp+X+2]	; color green
		shr	ah,cl
		mov	colormapg[bx], ah
		pop	bp
		ret

; 0
dztbl		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
; 1
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000001b
; 2
		db	00000000b
		db	00000000b
		db	00000000b
		db	00010000b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000001b
; 3
		db	00000000b
		db	00000000b
		db	00000000b
		db	00010001b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000001b
; 4
		db	00000000b
		db	00000000b
		db	00000000b
		db	00010001b
		db	00000000b
		db	00000000b
		db	00000000b
		db	00010001b
; 5
		db	00000000b
		db	00000000b
		db	00000000b
		db	00010001b
		db	00000000b
		db	00000100b
		db	00000000b
		db	00010001b
; 6
		db	00000000b
		db	01000000b
		db	00000000b
		db	00010001b
		db	00000000b
		db	00000100b
		db	00000000b
		db	00010001b
; 7
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010001b
		db	00000000b
		db	00000100b
		db	00000000b
		db	00010001b
; 8
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010001b
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010001b
; 9
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010001b
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010101b
; 10
		db	00000000b
		db	01000100b
		db	00000000b
		db	01010001b
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010101b
; 11
		db	00000000b
		db	01000100b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01000100b
		db	00000000b
		db	00010101b
; 12
		db	00000000b
		db	01000100b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01000100b
		db	00000000b
		db	01010101b
; 13
		db	00000000b
		db	01000100b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01000101b
		db	00000000b
		db	01010101b
; 14
		db	00000000b
		db	01010100b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01000101b
		db	00000000b
		db	01010101b
; 15
		db	00000000b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01000101b
		db	00000000b
		db	01010101b
; 16
		db	00000000b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01010101b
; 17
		db	00000000b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000010b
		db	01010101b
; 18
		db	00000000b
		db	01010101b
		db	00100000b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000010b
		db	01010101b
; 19
		db	00000000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00000010b
		db	01010101b
; 20
		db	00000000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	00000000b
		db	01010101b
		db	00100010b
		db	01010101b
; 21
		db	00000000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	00001000b
		db	01010101b
		db	00100010b
		db	01010101b
; 22
		db	10000000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	00001000b
		db	01010101b
		db	00100010b
		db	01010101b
; 23
		db	10001000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	00001000b
		db	01010101b
		db	00100010b
		db	01010101b
; 24
		db	10001000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	10001000b
		db	01010101b
		db	00100010b
		db	01010101b
; 25
		db	10001000b
		db	01010101b
		db	00100010b
		db	01010101b
		db	10001010b
		db	01010101b
		db	00100010b
		db	01010101b
; 26
		db	10101000b
		db	01010101b
		db	10100010b
		db	01010101b
		db	10001010b
		db	01010101b
		db	00100010b
		db	01010101b
; 27
		db	10101010b
		db	01010101b
		db	00100010b
		db	01010101b
		db	10001010b
		db	01010101b
		db	00100010b
		db	01010101b
; 28
		db	10101010b
		db	01010101b
		db	00100010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	00100010b
		db	01010101b
; 29
		db	10101010b
		db	01010101b
		db	00100010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	00101010b
		db	01010101b
; 30
		db	10101010b
		db	01010101b
		db	10100010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	00101010b
		db	01010101b
; 31
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	00101010b
		db	01010101b
; 32
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
; 33
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010111b
; 34
		db	10101010b
		db	01010101b
		db	10101010b
		db	01110101b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010111b
; 35
		db	10101010b
		db	01010101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01010111b
; 36
		db	10101010b
		db	01010101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	01010101b
		db	10101010b
		db	01110111b
; 37
		db	10101010b
		db	01010101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	01011101b
		db	10101010b
		db	01110111b
; 38
		db	10101010b
		db	11010101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	01011101b
		db	10101010b
		db	01110111b
; 39
		db	10101010b
		db	11011101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	01011101b
		db	10101010b
		db	01110111b
; 40
		db	10101010b
		db	11011101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	11011101b
		db	10101010b
		db	01110111b
; 41
		db	10101010b
		db	11011101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	11011111b
		db	10101010b
		db	01110111b
; 42
		db	10101010b
		db	11111101b
		db	10101010b
		db	01110111b
		db	10101010b
		db	11011111b
		db	10101010b
		db	01110111b
; 43
		db	10101010b
		db	11111111b
		db	10101010b
		db	01110111b
		db	10101010b
		db	11011111b
		db	10101010b
		db	01110111b
; 44
		db	10101010b
		db	11111111b
		db	10101010b
		db	01110111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	01110111b
; 45
		db	10101010b
		db	11111111b
		db	10101010b
		db	01110111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	01111111b
; 46
		db	10101010b
		db	11111111b
		db	10101010b
		db	11110111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	01111111b
; 47
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	01111111b
; 48
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
; 49
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101011b
		db	11111111b
; 50
		db	10101010b
		db	11111111b
		db	10111010b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101011b
		db	11111111b
; 51
		db	10101010b
		db	11111111b
		db	10111011b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10101011b
		db	11111111b
; 52
		db	10101010b
		db	11111111b
		db	10111011b
		db	11111111b
		db	10101010b
		db	11111111b
		db	10111011b
		db	11111111b
; 53
		db	10101010b
		db	11111111b
		db	10111011b
		db	11111111b
		db	10101110b
		db	11111111b
		db	10111011b
		db	11111111b
; 54
		db	11101010b
		db	11111111b
		db	10111011b
		db	11111111b
		db	10101110b
		db	11111111b
		db	10111011b
		db	11111111b
; 55
		db	11101110b
		db	11111111b
		db	10111011b
		db	11111111b
		db	10101110b
		db	11111111b
		db	10111011b
		db	11111111b
; 56
		db	11101110b
		db	11111111b
		db	10111011b
		db	11111111b
		db	11101110b
		db	11111111b
		db	10111011b
		db	11111111b
; 57
		db	11101110b
		db	11111111b
		db	10111011b
		db	11111111b
		db	11101111b
		db	11111111b
		db	10111011b
		db	11111111b
; 58
		db	11111110b
		db	11111111b
		db	10111011b
		db	11111111b
		db	11101111b
		db	11111111b
		db	10111011b
		db	11111111b
; 59
		db	11111111b
		db	11111111b
		db	10111011b
		db	11111111b
		db	11101111b
		db	11111111b
		db	10111011b
		db	11111111b
; 60
		db	11111111b
		db	11111111b
		db	10111011b
		db	11111111b
		db	11111111b
		db	11111111b
		db	10111011b
		db	11111111b
; 61
		db	11111111b
		db	11111111b
		db	10111011b
		db	11111111b
		db	11111111b
		db	11111111b
		db	10111111b
		db	11111111b
; 62
		db	11111111b
		db	11111111b
		db	11111011b
		db	11111111b
		db	11111111b
		db	11111111b
		db	10111111b
		db	11111111b
; 63
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	10111111b
		db	11111111b
; 64
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b
		db	11111111b

dzcoltbl:
; 0
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000000b
; 1
		db	00000000b
		db	00000000b
		db	00000000b
		db	00000001b
; 2
		db	00000000b
		db	00010000b
		db	00000000b
		db	00000001b
; 3
		db	00000000b
		db	00010001b
		db	00000000b
		db	00000001b
; 4
		db	00000000b
		db	00010001b
		db	00000000b
		db	00010001b
; 5
		db	00000000b
		db	00010001b
		db	00000100b
		db	00010001b
; 6
		db	01000000b
		db	00010001b
		db	00000100b
		db	00010001b
; 7
		db	01000100b
		db	00010001b
		db	00000100b
		db	00010001b
; 8
		db	01000100b
		db	00010001b
		db	01000100b
		db	00010001b
; 9
		db	01000100b
		db	00010001b
		db	01000101b
		db	00010001b
; 10
		db	01010100b
		db	00010001b
		db	01000101b
		db	00010001b
; 11
		db	01010101b
		db	00010001b
		db	01000101b
		db	00010001b
; 12
		db	01010101b
		db	00010001b
		db	01010101b
		db	00010001b
; 13
		db	01010101b
		db	00010001b
		db	01010101b
		db	00010101b
; 14
		db	01010101b
		db	01010001b
		db	01010101b
		db	00010101b
; 15
		db	01010101b
		db	01010101b
		db	01010101b
		db	00010101b
; 16
		db	01010101b
		db	01010101b
		db	01010101b
		db	01010101b
;---------------------------------------
;**
;**	Box Fill routine
;**
;**	void boxfill( x1, y1, x2, y2, col);
;**
;**	int x1, y1; ... Start point
;**     int x2, y2; ... End point
;**			x1 <= x2, y1 <= y2
;**	int col;    ... Color map address
;**
boxfill_arg	struc
		db	X dup (?)
x1		dw	?
y1		dw	?
x2		dw	?
y2		dw	?
col		dw	?
boxfill_arg	ends

patsiz		equ	8

boxfill_loc	struc
maskl		dw	?
maskr		dw	?
boxstart	dw	?
boxcount	dw	?
patb		dw	patsiz dup(?)
patbtmp		dw	patsiz dup(?)
boxfill_loc	ends

loc		=	size boxfill_loc

boxfill		proc	near
		push	bp
		mov	bp, sp
		sub	sp, loc			; local variable size
		push	ds
		push	si
		push	di

		cmp	[mode], -1		; Resident ?
		jz	_box30			; Yes
;
;	Check Key break
;
		mov	ah,6
		mov	dl,0ffh
		int	bdos
		or	al,al			; Hit any key ?
		jz	_box30
		push	ds			; Break
		push	bx
		lds	bx, [save_Sflag]
		mov	word ptr [bx], -1
		pop	bx
		pop	ds
		jmp	_boxret
;-----------------------------------------
;	set color pattern
;-----------------------------------------
_box30:
		cmp	[grphflg],false
		jz	_box30r
		mov	di, [bp.col]		; get map data
		cmp	di, -1			;+
		jnz	_box30a			;+
_box30r:	jmp	_boxret			;+

;
;	Ygb = (G*2+B)*16/21
;	Yr  = R*16/7
;	{0 <= Ygb,Yr <= 16}
;	{0 <= G,R,B  <= 7}
;
_box30a:
		test	[colflg],0ffh
		jz	_box30b
		mov	al, colormapg[di]
		add	al,al
		add	al, colormapb[di]
		mov	bl, 16
		mul	bl
		mov	bl, 21
		div	bl
		mov	bl, al
		mov	bh, 0
		shl	bx, 1
		shl	bx, 1
		xor	si, si
		lea	bx, dzcoltbl[bx]
		mov	cx, patsiz/2
_box32a:	mov	al, cs:[bx]
		mov	ah, al
		inc	bx
		mov	[bp+si-loc].patb, ax
		mov	[bp+si-loc+4*2].patb, ax
		inc	si
		inc	si
		loop	_box32a
		mov	al,colormapr[di]
		mov	bl,16
		mul	bl
		mov	bl,7
		div	bl
		mov	bl, al
		mov	bh, 0
		shl	bx, 1
		shl	bx, 1
		xor	si, si
		lea	bx, dzcoltbl[bx]
		mov	cx, patsiz/2
_box32b:	mov	al, cs:[bx]
		shl	al,1
		mov	ah, al
		inc	bx
		or	[bp+si-loc].patb, ax
		or	[bp+si-loc+4*2].patb, ax
		inc	si
		inc	si
		loop	_box32b
		jmp	_box10

_box30b:
;
;	Y = (G*38+R*19+B*7)/7
;	{0 <= Y <= 64}
;	{0 <= G,R,B <= 7}
;
		mov	bl, colormapg[di]
		mov	al, 38			; green
		mul	bl
		mov	dx, ax
		mov	bl, colormapr[di]
		mov	al, 19			; red
		mul	bl
		add	ax, dx
		mov	bl, 7
		div	bl
		sub	ah, ah
		mov	bl, colormapb[di]
		mov	bh, 0			; blue
		add	bx, ax
		cmp	[negaflg],false
		jz	_box31
		sub	bx, 64
		neg	bx
_box31:		mov	cl, 3
		shl	bx, cl
		lea	bx, dztbl[bx]
		xor	si, si
		mov	cx, patsiz
_box32:		mov	al, cs:[bx]
		mov	ah, al
		inc	bx
		mov	[bp+si-loc].patb, ax
		inc	si
		inc	si
		loop	_box32
;-----------------------------------------
;	line buffer data set
;-----------------------------------------
_box10:
		cld
		mov	ax, [bp.x1]
		mov	dx, ax
		test	[colflg],0ffh
		jz	_box10a
		mov	cl, 3
		shr	dx, cl
		mov	cl, al
		and	cl, 7
		shl	cl, 1
		jmp	short _box10b
_box10a:
		mov	cl, 4
		shr	dx, cl
		mov	cl, al
		and	cl, 0Fh
_box10b:
		mov	[bp-loc].boxstart, dx
		mov	ax, 0FFFFh
		shr	ax, cl
		xchg	ah, al
		not	ax
		mov	[bp-loc].maskl, ax	; start mask pattern
		mov	bx, [bp.x2]
		test	[colflg], 0ffh
		mov	cl, 4
		jz	_box11a
		mov	cl, 3
_box11a:
		shr	bx, cl
		sub	bx, dx
		jnz	_box11
		jmp	_box40
_box11:		cmp	word ptr [bp-loc].maskl, 0
		jnz	_box12
		inc	bx
_box12:		mov	[bp-loc].boxcount, bx
		mov	cl, byte ptr [bp.x2]
		test	[colflg], 0ffh
		jz	_box12a
		mov	ax, 03fffh
		and	cl, 7
		shl	cl, 1
		jmp	short _box12b
_box12a:
		mov	ax, 07FFFh
		and	cl, 0Fh
_box12b:
		shr	ax, cl
		xchg	ah, al
		and	ax, ax
		jz	_box13
		dec	[bp-loc].boxcount
_box13:		mov	[bp-loc].maskr, ax
;---------------------------------------
;	line output
;---------------------------------------
_box20:
		mov	ax, [bp.y1]
		mov	si, ax
		shl	si, 1
		and	si, patsiz*2-1
		xor	bx,bx
		shr	ax, 1
		jnc	_box201
		mov	bx, 2000h
_box201:
		mov	dx, 40
		mul	dx
		add	ax, [bp-loc].boxstart
		mov	di, ax
		shl	di, 1
		add	di, bx
		mov	cx, [bp.y2]
		sub	cx, [bp.y1]
		inc	cx
		push	si
		push	di
		push	cx
		mov	dx, [bp-loc].maskl
		and	dx, dx
		jz	_box22
		call	_boxs00
		pop	cx
		pop	di
		pop	si
		push	si
		lea	ax, [di+2]
		push	ax
		push	cx
		mov	dx, [bp-loc].maskl
		call	_boxs10
_box22:		mov	bx, [bp-loc].boxcount
		and	bx, bx
		jz	_box25
		pop	cx
		pop	di
		pop	si
		shl	bx, 1
		lea	ax, [di+bx]
		push	si
		push	ax
		push	cx
		mov	ax, GVRAM
		mov	es, ax
_box23:		push	cx		; save counter
		push	di		; save address
		mov	cx, [bp-loc].boxcount
		mov	ax, [bp+si-loc].patb
_box24:
	rep	stosw			; set blue
		pop	di
		pop	cx
		xor	di, 2000h
		test	di, 2000h
		jnz	_box241
		add	di, 80
_box241:
		add	si, 2
		and	si, patsiz*2-1
		loop	_box23
_box25:		pop	cx
		pop	di
		pop	si
		mov	dx, [bp-loc].maskr
		and	dx, dx
		jz	_boxret
		push	di
		push	si
		push	cx
		call	_boxs00
		pop	cx
		pop	si
		pop	di
		mov	dx, [bp-loc].maskr
		call	_boxs10
_boxret:
		pop	di
		pop	si
		pop	ds
		mov	sp, bp
		pop	bp
		ret

_box40:
		mov	cl, byte ptr [bp.x2]
		test	[colflg], 0ffh
		jz	_box40a
		and	cl, 7
		shl	cl, 1
		mov	dx, 3fffh
		jmp	short _box40b
_box40a:
		and	cl, 0Fh
		mov	dx, 7FFFh
_box40b:
		shr	dx, cl
		xchg	dh, dl
		or	dx, [bp-loc].maskl	; set mask pattern
		push	dx
		call	_boxs00			; set color pattern
		mov	ax, [bp.y1]
		mov	cx, [bp.y2]
		sub	cx, ax
		inc	cx			; set counter
		mov	si, ax
		shl	si, 1
		and	si, patsiz*2-1
		xor	bx,bx
		shr	ax, 1
		jnc	_box41
		mov	bx, 2000h
_box41:
		mov	dx, 40
		mul	dx
		add	ax, [bp-loc].boxstart
		mov	di, ax
		pop	dx
		shl	di, 1
		add	di, bx
		call	_boxs10
		jmp	_boxret

;=======================================
;	DX	mask pattern
;=======================================
_boxs00:				; set color pattern
		not	dx
		mov	ax, ss
		mov	ds, ax
		mov	es, ax
		mov	cx, patsiz
		lea	si, [bp-loc].patb
		lea	di, [bp-loc].patbtmp
_boxs01:	lodsw
		and	ax, dx
		stosw
		loop	_boxs01
		ret

;=======================================
;	DI	distination address
;	SI	color pattern
;	DX	mask pattern
;	CX	counter
;=======================================
_boxs10:	
		mov	ax, GVRAM
		mov	ds, ax
_boxs11:	mov	ax, [di]
		and	ax, dx
		or	ax, [bp+si-loc].patbtmp
		mov	[di], ax
		xor	di, 2000h
		test	di, 2000h
		jnz	_boxs12
		add	di, 80
_boxs12:
		add	si, 2
		and	si, patsiz*2-1
		loop	_boxs11
		ret

boxfill		endp

		db	"End of OVL module"
_TEXT		ends
		end
