/**** Network errors ****/
/* Decimal values at end of line are 32768 lower than actual */

#define INVALID_CONNECTION					0x8001	/*   1 */
#define DRIVE_IN_USE						0x8002	/*   2 */
#define CANT_ADD_CDS						0x8003	/*   3 */
#define BAD_DRIVE_BASE						0x8004	/*   4 */
#define NET_READ_ERROR						0x8005	/*   5 */
#define UNKNOWN_NET_ERROR					0x8006	/*   6 */
#define SERVER_INVALID_SLOT					0x8007	/*   7 */
#define NO_SERVER_SLOTS						0x8008	/*   8 */
#define NET_SEND_ERROR						0x8009	/*   9 */
#define SERVER_NO_ROUTE						0x800a	/*  10 */
#define BAD_LOCAL_TARGET					0x800b	/*  11 */
#define TOO_MANY_REQ_FRAGS					0x800c	/*  12 */
#define CONNECT_LIST_OVERFLOW				0x800d	/*  13 */
#define BUFFER_OVERFLOW						0x800e	/*  14 */
#define NO_CONNECTION_TO_SERVER				0x800f	/*  15 */
#define NO_ROUTER_FOUND						0x8010	/*  16 */
#define INVALID_SHELL_CALL					0x8011	/*  17 */
#define NOT_SAME_CONNECTION					0x8030	/*  48 */
#define PRIMARY_CONNECTION_NOT_SET			0x8031	/*  49 */
#define NO_CAPTURE_IN_PROGRESS				0x8032	/*  50 */
#define INVALID_BUFFER_LENGTH				0x8033	/*  51 */
#define NO_USER_NAME						0x8034  /*  52 */
#define NO_NETWARE_PRINT_SPOOLER			0x8035	/*  53 */
#define INVALID_PARAMETER					0x8036	/*  54 */
#define FILE_IN_USE_ERROR					0x8080	/* 128 */
#define NO_MORE_FILE_HANDLES				0x8081	/* 129 */
#define NO_OPEN_PRIVILEGES					0x8082	/* 130 */
#define IO_ERROR_NETWORK_DISK				0x8083	/* 131 */
#define NO_CREATE_PRIVILEGES				0x8084	/* 132 */
#define NO_CREATE_DELETE_PRIVILEGES			0x8085	/* 133 */
#define CREATE_FILE_EXISTS_READ_ONLY		0x8086	/* 134 */
#define WILD_CARDS_IN_CREATE_FILE_NAME		0x8087	/* 135 */
#define INVALID_FILE_HANDLE					0x8088	/* 136 */
#define NO_SEARCH_PRIVILEGES				0x8089	/* 137 */
#define NO_DELETE_PRIVILEGES				0x808a	/* 138 */
#define NO_RENAME_PRIVILEGES				0x808b	/* 139 */
#define NO_MODIFY_PRIVILEGES				0x808c	/* 140 */
#define SOME_FILES_AFFECTED_IN_USE			0x808d	/* 141 */
#define NO_FILES_AFFECTED_IN_USE			0x808e	/* 142 */
#define SOME_FILES_AFFECTED_READ_ONLY		0x808f	/* 143 */
#define NO_FILES_AFFECTED_READ_ONLY			0x8090	/* 144 */
#define SOME_FILES_RENAMED_NAME_EXISTS		0x8091	/* 145 */
#define NO_FILES_RENAMED_NAME_EXISTS		0x8092	/* 146 */
#define NO_READ_PRIVILEGES					0x8093	/* 147 */
#define NO_WRITE_PRIVILEGES_OR_READONLY		0x8094	/* 148 */
#define FILE_DETACHED						0x8095	/* 149 */
#define SERVER_OUT_OF_MEMORY				0x8096	/* 150 */
#define NO_DISK_SPACE_FOR_SPOOL_FILE		0x8097	/* 151 */
#define VOLUME_DOES_NOT_EXIST				0x8098	/* 152 */
#ifndef DIRECTORY_FULL
#define DIRECTORY_FULL						0x8099	/* 153 */
#endif
#define RENAMING_ACROSS_VOLUMES				0x809a	/* 154 */
#define BAD_DIRECTORY_HANDLE				0x809b	/* 155 */
#define INVALID_PATH						0x809c	/* 156 */
#define NO_MORE_TRUSTEES					0x809c
#define NO_MORE_DIRECTORY_HANDLES			0x809d	/* 157 */
#define INVALID_FILENAME					0x809e	/* 158 */
#define DIRECTORY_ACTIVE					0x809f	/* 159 */
#define DIRECTORY_NOT_EMPTY					0x80a0	/* 160 */
#define DIRECTORY_IO_ERROR					0x80a1	/* 161 */
#define READ_FILE_WITH_RECORD_LOCKED		0x80a2	/* 162 */
#define LOGIN_DENIED_NO_ACCOUNT_BALANCE		0x80c1	/* 193 */
#define LOGIN_DENIED_NO_CREDIT				0x80c2	/* 194 */
#define INTRUDER_DETECTION_LOCK				0x80c5	/* 197 */
#define PASSWORD_NOT_UNIQUE					0x80d7	/* 215 */
#define PASSWORD_TOO_SHORT					0x80d8	/* 216 */
#define LOGIN_DENIED_NO_CONNECTION			0x80d9	/* 217 */
#define UNAUTHORIZED_LOGIN_TIME				0x80da	/* 218 */
#define UNAUTHORIZED_LOGIN_STATION			0x80db	/* 219 */
#define ACCOUNT_DISABLED					0x80dc	/* 220 */
#define PASSWORD_HAS_EXPIRED_NO_GRACE		0x80de	/* 222 */
#define PASSWORD_HAS_EXPIRED				0x80df	/* 223 */
#define NOT_ITEM_PROPERTY					0x80e8	/* 232 */
#define WRITE_PROPERTY_TO_QROUP				0x80e8
#define MEMBER_ALREADY_EXISTS				0x80e9	/* 233 */
#define NO_SUCH_MEMBER						0x80ea	/* 234 */
#define NOT_GROUP_PROPERTY					0x80eb	/* 235 */
#define NO_SUCH_SEGMENT						0x80ec	/* 236 */
#define PROPERTY_ALREADY_EXISTS				0x80ed	/* 237 */
#define OBJECT_ALREADY_EXISTS				0x80ee	/* 238 */
#define INVALID_NAME						0x80ef	/* 239 */
#define WILD_CARD_NOT_ALLOWED				0x80f0	/* 240 */
#define INVALID_BINDERY_SECURITY			0x80f1	/* 241 */
#define NO_OBJECT_READ_PRIVILEGE			0x80f2	/* 242 */
#define NO_OBJECT_RENAME_PRIVILEGE			0x80f3	/* 243 */
#define NO_OBJECT_DELETE_PRIVILEGE			0x80f4	/* 244 */
#define NO_OBJECT_CREATE_PRIVILEGE			0x80f5	/* 245 */
#define NO_PROPERTY_DELETE_PRIVILEGE		0x80f6	/* 246 */
#define NOT_SAME_LOCAL_DRIVE 				0x80f6
#define NO_PROPERTY_CREATE_PRIVILEGE		0x80f7	/* 247 */
#define TARGET_DRIVE_NOT_LOCAL				0x80f7
#define ALREADY_ATTACHED_TO_SERVER			0x80f8	/* 248 */
#define NO_PROPERTY_WRITE_PRIVILEGE			0x80f8
#define NOT_ATTACHED_TO_SERVER				0x80f8
#define NO_FREE_CONNECTION_SLOTS			0x80f9	/* 249 */
#define NO_PROPERTY_READ_PRIVILEGE			0x80f9
#define NO_MORE_SERVER_SLOTS				0x80fa	/* 250 */
#define TEMP_REMAP_ERROR					0x80fa
#define INVALID_PARAMETERS					0x80fb	/* 251 */
#define NO_SUCH_PROPERTY					0x80fb
#define INTERNET_PACKET_REQT_CANCELED		0x80fc	/* 252 */
#define UNKNOWN_FILE_SERVER					0x80fc
#define MESSAGE_QUEUE_FULL					0x80fc
#define NO_SUCH_OBJECT						0x80fc
#define BAD_STATION_NUMBER					0x80fd	/* 253 */
#define INVALID_PACKET_LENGTH				0x80fd
#define UNKNOWN_REQUEST						0x80fd
#define BINDERY_LOCKED						0x80fe	/* 254 */
#define DIRECTORY_LOCKED					0x80fe
#define INVALID_SEMAPHORE_NAME_LENGTH		0x80fe
#define PACKET_NOT_DELIVERABLE				0x80fe
#define SERVER_BINDERY_LOCKED				0x80fe
#define SOCKET_TABLE_FULL					0x80fe
#define SPOOL_DIRECTORY_ERROR				0x80fe
#define SUPERVISOR_HAS_DISABLED_LOGIN		0x80fe
#define TIMEOUT_FAILURE						0x80fe
#define BAD_PRINTER_ERROR					0x80ff	/* 255 */
#define BAD_RECORD_OFFSET					0x80ff
#define CLOSE_FCB_ERROR						0x80ff
#define FILE_EXTENSION_ERROR				0x80ff
#define FILE_NAME_ERROR						0x80ff
#define HARDWARE_FAILURE					0x80ff
#define INVALID_DRIVE_NUMBER				0x80ff
#define INVALID_INITIAL_SEMAPHORE_VALUE		0x80ff
#define INVALID_SEMAPHORE_HANDLE			0x80ff
#define IO_BOUND_ERROR						0x80ff
#define NO_FILES_FOUND_ERROR				0x80ff
#define NO_RESPONSE_FROM_SERVER				0x80ff
#define NO_SUCH_OBJECT_OR_BAD_PASSWORD		0x80ff
#define PATH_NOT_LOCATABLE					0x80ff
#define QUEUE_FULL_ERROR					0x80ff
#define REQUEST_NOT_OUTSTANDING				0x80ff
#define SOCKET_ALREADY_OPEN					0x80ff
#define NO_CONSOLE_OPERATOR					0x80c6

