


                         SYSTEM DEFAULTS AND DEFINITIONS

                                       for

                 Pascal Integrated Communications System (PICS)

                            Version 1.0  August 1,1986
                                 Les Archambault

-------------------------------------------------------------------------
2/10/87 This file is being included in the documentation for PICSPC,
        the IBM PC version for informational purposes only. Many of the
        defaults have been changed or eliminated when the conversion
        required it. As an example, the number of drives is not required
        for the PC version.
-------------------------------------------------------------------------

        PICS.PAS and the associated support files (including this
        documentation file) are Copyright (c) 1986 by Les Archambault.
        Non-commercial, public distribution and use of this system is
        permitted.  All commercial rights are reserved. Distribution of
        PICS should include this documentation.

        The following are the system defined default values.  These
        values, set in PICSDEF.INC, may be changed by the SYSOP on an
        individual basis.

2/6/87  After being changed from the 'C'hange command in the Sysop menu,
        a file named CONFIG.BB# is created and will retain the new settings.

        * The default values marked with a star (*) can be set from 
        within PICS from the Sysop Change menu. All changes will 
        remain in effect while PICS is running. If PICS is exited by 
        the Sysop, then re-entered, the default values will again be 
        in effect.
         
        'Num_Drives' 
        The number of drives that you have on your system less one. That 
        is... if you have four drives set Num_Drives at 3. If you have two 
        drives Num_Drives would be 1. PICS uses this value for allocating 
        space when reading disk directories. 
        Distribution value = 3 (four drives.)
         
        'Mhz' 
        The operating speed of your machine in megahertz or megacycles. 
        This is a real number and must be entered with a decimal point and 
        0 if there are no decimal numbers. This setting is used for all 
        the timing loops inside of PICS, as well as the timing during file 
        transfer. The value may be adjusted slightly if there is a 
        noticeable problem with the timing. As a test, when Chat is 
        requested the console bell should ring for about 30 seconds. 
        Distribution value = 4.0
         
        -----------------------------------------------------------

        PICS has built in routines for guarding against your disks 
        becoming full and causing a crash. As the disks become full, a 
        controlled shutdown of functions takes place. The next five 
        settings control when this takes place.

        When any of the following limits are reached, PICS will display 
        a message to the Sysop on the local console during the 
        'bouncing cursor' routine while it is waiting for the next 
        caller. This occurs about every fifth 'bounce' of the cursor.

        *  'Def_Maxfree_Uplds'
        ----------------------
        Files that are uploaded to PICS are written to the NEWIN section 
        in the files sub-system. When there is less than Def_Maxfree_Uplds 
        (in K bytes) of free space left on the disk, callers are not 
        permitted to send files to PICS. This test operates on the drive
        set (with the Setup program) for the NEWIN section.
                          
        In the case of conferences the uploads will go directly to the 
        drive that you have set with the Setup program. Unless this is 
        the same drive as the NEWIN section, no checking for a full 
        disk will be done.
        Distribution value = 50 (K)
         
        *  'Def_maxfree_logs'
        --------------------
        This value represents the minimum disk space on the system disk 
        (where the .COM file and overlays reside) to continue to allow new 
        callers to register on the system. If less than this amount of 
        space is left, the caller will be told that new logins can't be 
        accepted and asked to call in later.
        Distribution value = 25 (K)

        *  'Def_maxfree_Mslimit'
        -----------------------
        When there is less than this amount of free space available on 
        the system drive, PICS will limit the number of lines that can 
        be entered in a message to the value in the next setting. 
        There is a separate setting (discussed later) for manually 
        limiting the number of message lines all the time.
        Distribution value = 20 (K)

        *  'Def_maxfree_lines'
        ---------------------
        This is the number of lines that messages are limited to when 
        there is not at least the amount of free disk space set in the 
        Def_maxfree_mslimit value above.
        Distribution value = 10 (lines)

        *  'Def_maxfree_Abs'
        -------------------
        If there is less than this amount of free space on the system 
        disk all message entry is prohibited. Callers trying to enter 
        messages are informed that there isn't enough disk space for 
        messages. This value should be less than any of the values 
        above.
        Distribution setting = 5 (k)

        If there is less than the Def_Maxfree_Abs amount of free disk 
        space on the system drive, only callers already known to the 
        system will be allowed in, and they will be able to do 
        everything but upload and enter messages.

        ---------------------------------------------------------------

        *  'Def_Uval_Acc' and 'Def_Uval_Time'
        ------------------------------------
        The access level and time per day assigned to new users who 
        are not known to the system. The minimum settings you have 
        assigned to the 'Message Areas', 'File Sections' and 
        'Articles' will determine what the new caller can see on the 
        system. At a minimum, new callers should be able to see the 
        POST Message area and the LOGIN File Section. PICS keeps track 
        of the total time per day (24 hours) that each caller uses. If 
        this total is greater than the Def_Uval_Time then the system 
        will notify the caller two minutes before it will hang up.
        Distribution value Def_Uval_Acc = 10
        Distribution value Def_Uval_Time = 20 (minutes)

        NOTE: If you set the value of Def_Uval_Acc to the same or greater 
        value than the setting for Dev_Val_Acc (below) you are creating an 
        OPEN system where callers DO NOT require verification by the Sysop 
        before obtaining the same status as validated users.
         
        'Def_Chars' and 'Def_Lines'
        --------------------------- 
        The number of characters-per-line and lines-per-page (screen) 
        assigned to a new caller who is unknown to the system. The 
        caller may reset the number of lines per page in the Utilities 
        sub-system, but the characters per line (screen width) is 
        constant, depending on the caller's terminal to generate 
        carriage returns and line feeds for smaller screens.
        Distribution value Def_Chars = 80
        Distribution value Def_Lines = 23

        *  'Def_Val_Acc' and 'Def_Val_Time'
        ----------------------------------
        The access level and time per day that are assigned to a 
        caller upon being validated by the Sysop. 
        Distribution value Def_Val_Acc = 20
        Distribution value Def_Val_Time = 45 (minutes)

        *  'Def_Chat_OK'
        ----------------
        A toggle that when OFF prevents all attempts for callers to 
        chat with the Sysop. The caller is told that the Chat function 
        is not active. When the toggle is ON, the Chat function 
        responds to the limits set in the following values.
        Distribution value = True (ON)
                  
        *  'Def_ChatStart'  and 'Def_ChatEnd'
        ------------------------------------
        The hours during which the Sysop will be paged on the local 
        system console. Outside of these hours the caller will be told 
        what the Chatting hours are, but no paging of the Sysop will 
        be done. These settings are in whole hours only, no minutes. 
        All values for hours use a 24 hour notation (0-24).
        Distribution value Def_ChatStart = 19  (7 PM)
        Distribution value Def_ChatEnd   = 22

        'Fence'
        ------
        The separator  used  by the directory routine between columns 
        during display.
        Distribution value = |

        *  'Def_Unv_Days'  and  'Def_Val_Days'
        -----------------------------
        The number of days allowed to elapse between calls before the 
        inactive user is purged from the system. For example, 14 and 
        180 will allow unvalidated users to remain on the system for 
        14 days between calls and validated users 180 days between 
        calls before being deleted from the user file during a purge 
        operation.
        Distribution value Def_Unv_Days = 14
        Distribution value Def_Val_Days = 180 
                  
        *  'Def_Unr_Days'  and  'Def_Rea_Days'
        -------------------------------------
        The number of days allowed to elapse before unread and read 
        messages, respectively, are automatically deleted from the 
        message file during a purge operation.  Public messages are 
        never marked as read and thus will be available until 
        explicitly deleted or until they "expire" as determined by 
        'unr_days.' All messages are subject to these time limits 
        unless they have been marked as <P>rotected by the Sysop. Any 
        messages marked as deleted remain in the message file until 
        the next purge operation, but are automatically purged even 
        though the number of days is less than the values above.
        Distribution value Def_Unr_Days = 90                           
        Distribution value Def_Rea_Days = 14

        *  'Max_Tries'
        -------------
        The number of times PICS will allow a user to attempt password 
        or name entry.  If this number is exceeded, the system will 
        disconnect with a message.
        Distribution value = 3                  

        -------------------------------------------------------------
        PICS has the ability to execute commands automatically and 
        unattended, just as if the sysop were sitting at the local 
        console. This feature is called Macro Processing. (A macro is 
        a string of characters and delimiters which represent 
        commands.)
        Here's how it works:
        If the Auto Macro processing is ON and the current hour is greater 
        than the hour set for auto operation, PICS will wait for the 
        current caller to hang up (if there is a caller) then it will make 
        the modem busy to prevent more calls. Then it will log the sysop 
        into the system automatically and pass the current Macro string to 
        the multiple command buffer for execution. After completion of the 
        commands, PICS will log off the system (this must be the final 
        command in the Macro string) and put the phone back on the hook. 
        The maximum length of the Macro string is 80 characters, including 
        delimiters (spaces, commas, semi-colons). Care must be taken to 
        make sure all required key strokes are included in the Macro 
        string, especially the final command to log the Sysop off the 
        system. Carriage returns can be put into the string by using an up 
        arrow and M (^M). It is the Sysop's responsibility to make sure of 
        this, or the system will sit and wait for further input from the 
        local keyboard! I recommend that before making the Macro automatic 
        it be tested by the Sysop.
                  
        *  'Deflt_Macro'
        ----------------
        The actual macro string of characters and delimiters.
        Distribution value = S;N;G

        * 'Def_Auto_Macro'
        -----------------
        This toggle when ON enables the execution of the Deflt_Macro 
        string at the time set. When OFF, no macro execution takes 
        place.
        Distribution value = False (OFF)

        *  'Def_Auto_Macro_Start'
        ------------------------
        The hour (0-24) to start executing the macro string. Since 
        this feature finishes when the last command is processed, 
        there is no STOP setting.
        Distribution value = 4 (4 A.M.)

        *  'Def_Restrict300'
        --------------------
        This toggle when ON will not accept callers at 300 baud 
        between the preset hours. After connecting with the system 
        they will be notified of the hours when 300 baud calling is 
        restricted, then PICS will hang up. When OFF no restrictions 
        will be applied to 300 baud callers.
        Distribution value = False (OFF)

        *  'Def_Start_restrict300'
        -------------------------
        The hour (0-24) that restriction of 300 baud callers begins.
        Distribution value = 19  (7 P.M.)

        *  'Def_End_Restrict300'
        ------------------------
        The hour (0-24) that restriction of 300 baud caller ends.
        Distribution value = 23

        *  'Def_Limit_Lines'
        --------------------
        This toggle when ON limits the length of all messages entered 
        to the number of lines in the next definition. It is useful 
        when lots of messages are being entered on a system with 
        limited disk space. This setting has nothing to do with the 
        limiting of message lines that happens automatically when the 
        disk fills up to the settings above.
        Distribution value = False (OFF)

        *  'Def_Max_Msg_Lines'
        ---------------------
        The number of lines that messages will be limited to when the 
        above toggle is ON. During message entry, callers will be 
        warned 2 lines before the end of the message is reached.
        Distribution value = 100

        *  'Def_Restrict_Public'
        ------------------------
        This toggle when ON will automatically flag all messages 
        entered as Public by the sender. They will not be available 
        for viewing until released by the Sysop. Only messages entered 
        after the toggle has been turned on are affected. When OFF, 
        messages marked Public will be immediately available for 
        viewing.
        Distribution value = False  (OFF)

        *  'Def_Up_Down_Ratio'
        ----------------------
        This feature of PICS enables you to establish a ratio of 
        downloads to uploads for each user. When set to 0, no checking 
        of the user's ratio is performed. When set to any other value, 
        the user is limited to this number of downloads (from PICS to 
        the caller) per upload (caller to PICS). Example: If the 
        number is set to 20, users would only be able to download 20 
        files for each file that they uploaded after the first 20 
        files were sent from PICS to them.
        Distribution value = 20

        *  'Def_Sleepy_Time'
        --------------------
        This value sets the time (number of seconds) that the system 
        will wait for input from the modem (usually at prompts). After 
        this number of seconds with no input (typed by the caller) 
        PICS will print the message ++ Input Timed Out ++, log off the 
        caller and wait for the next call. This doesn't affect the 
        local console that the Sysop uses.
        Distribution value = 300 (seconds)

        *  'Def_Extra_Time'
        -------------------
        This toggle when ON and a call is received within the hours 
        set, adds extra time (in minutes) to the caller's time allowed 
        on the system (per day). This is done at the beginning of the 
        session. When OFF, nothing happens.
        Distribution value = True (ON)

        *  'Def_Extra_Time_Val'
        ----------------------
        The number of minutes to be added to caller's time allowed on 
        system when extra time is operating.
        Distribution value = 20 (minutes)

        *  'Def_Extra_Time_Start'
        -------------------------
        The hour (0-24) to begin adding the extra time to caller's 
        time allowed on system.
        Distribution value = 1 (1:00 A.M.)

        *  'Def_Extra_Time_Stop'
        ------------------------
        The hour at which extra time stops being added to caller's 
        time allowed on system.
        Distribution value = 7 (7:00 A.M.)

        'Def_Time_Adjust'
        -----------------
        This real number is a multiplier used only by PICS systems 
        without real time clocks. In these systems PICS simulates a 
        clock while waiting at prompts and during file transfers. PICS 
        also simulates clock ticking during the 'bouncing cursor' 
        routine while waiting for a caller. This is used to change the 
        day automatically. This adjustment is provided for fine tuning 
        of each system without real time clock so that the day changes 
        every 24 hours. To make the simulated clock faster, increase 
        the number. Only a small change should be required, say from 
        1.15 to 1.22.
        Distribution value = 1.15

        The rest of the constants in the PICSDEF.INC file should not 
        need to be changed, indeed some of them must NOT be changed.

        Les Archambault


         ----------------end-of-author's-documentation---------------

                        Software Library Information:

                   This disk copy provided as a service of

                        The Public (Software) Library

         We are not the authors of this program, nor are we associated
         with the author in any way other than as a distributor of the
         program in accordance with the author's terms of distribution.

         Please direct shareware payments and specific questions about
         this program to the author of the program, whose name appears
         elsewhere in  this documentation. If you have trouble getting
         in touch with the author,  we will do whatever we can to help
         you with your questions. All programs have been tested and do
         run.  To report problems,  please use the form that is in the
         file PROBLEM.DOC on many of our disks or in other written for-
         mat with screen printouts, if possible.  The P(s)L cannot de-
         bug programs over the telephone.

         Disks in the P(s)L are updated monthly, so if you did not get
         this disk  directly from the P(s)L,  you should be aware that
         the files in this set may no  longer be the current versions.

         For a copy of the latest monthly software library newsletter
         and a list of the 1,000+ disks in the library, call or write

                        The Public (Software) Library
                              P.O.Box 35705 - F
                           Houston, TX 77235-5705
                               (713) 665-7017

