(*****************************************************************************)
(*                                                                           *)
(*            PICSPC - Pascal Integrated Communications System               *)
(*                                                                           *)
(*                       Copyright (c) 1986 by                               *)
(*                       Les Archambault                                     *)
(*                                                                           *)
(*                   All commercial rights reserved.                         *)
(*                                                                           *)
(*    This program is based on ROS Vers 3.4 by Steve Fox. It is released     *)
(*    into the public domain for private use only. Additional thanks to:     *)
(*    Irv Hoff whose 1k protocal in KMD was invaluable in writing the        *)
(*    Turbo Pascal routines. The authors of DEARC for the basic code that    *)
(*    deals with Arc files. The author of ASYNC.ARC for the code to make     *)
(*    possible the interupt service routines.                                *)
(*    Special thanks to Lindsay Jones, Eric Daniel, Freeman Bradford and     *)
(*    John Van Hengel for beta testing and support.                          *)
(*                                                                           *)
(*****************************************************************************)

{For update & modification history see the file PPCUPD.HIS.}

program PICSPC;
{$C-}

const
  version = 'PICS-PC v1.1a';
  ver_date = '3/6/87';

{$I PPCDEF.INC}     {SYSTEM DEFAULTS}
{$I PPCVAR.INC}     {System Types and Variables}

  { Turbo Toolbox }
{$I ACCESS3.BOX}
{$I GETKEY.BOX}

var
  DatF: DataFile;
  IdxF: IndexFile;

  { Machine dependent code }
{$I PPCMCH.INC}                           { Computer and channel routines }
{$I PPCMDM.INC}                           { Modem routines }

  { System kernel }
{$I PPCKIO.INC}                             { I/O drivers - resident    }
{$I PPCKMS.INC}                             { Miscellaneous - resident  }
{$I PPCOV0A.INC}                            { Overlays for .000 file    }
{$I PPCOV0B.INC}                            {      "              "     }
{$I PPCOV0C.INC}                            {      "              "     }
{$I PPCOV0D.INC}                            {      "              "     }
{$I PPCOV0E.INC}                            {      "              "     }
{$I PPCOV0F.INC}                            {      "              "     }
{$I PPCOV0G.INC}                            {      "              "     }

  { Turbo Toolbox   NOTE: THESE ROUTINES SHOULD BE MADE INTO OVERLAYS    }
{$I ADDKEY.BOX}
{$I DELKEY.BOX}
{$I PPCOV0H.INC}                            { More overlays for the .000 file}
{$I PPCOV0I.INC}                            {      "              "     }

  { Force a new overlay }
type dummy = char;

{$I PPCOV2A.INC}                            { Overlays for the .002 file}
{$I PPCOV2B.INC}                            {       "            "      }
{$I PPCOV2C.INC}                            {       "            "      }
{$I PPCOV2D.INC}                            {       "            "      }
{$I PPCOV2E.INC}                            {       "            "      }
{$I PPCOV2F.INC}                            {       "            "      }
{$I PPCOV2G.INC}                            {       "            "      }
{$I PPCOV2H.INC}                            {       "            "      }
{$I PPCOV2I.INC}                            {       "            "      }
{$I PPCOV2J.INC}                            {       "            "      }
{$I PPCOV2K.INC}                            {       "            "      }
{$I PPCOV2L.INC}                            {       "            "      }

{$I PPCMAIN.INC}

{End of PICS.PAS}
