


                                  USERS MANUAL 

                                       for

                 Pascal Integrated Communications System (PICS)

                            Version 1.0  August 1,1986
                                 Les Archambault


     PICS.PAS and the associated support files (including this 
     documentation file) are Copyright (c) 1986 by Les Archambault.  Non-
     commercial, public distribution and use of this system is permitted.  
     All commercial rights are reserved. Distribution of PICS should 
     include this documentation.

     The following briefly describes the features of PICS, a completely 
     integrated message and file transfer system.

      
                            USER FUNCTIONS AVAILABLE

     *  Send and receive public and private messages in multiple message 
        areas.

     *  Can access multiple file areas and libraries.

     *  File directory is sorted with selectable file sizes or transfer 
        time.

     *  Send and receive files using Xmodem protocol (checksum and CRC, 
        regular or 1K block sizes, single file or batch modes.)

     *  Send text files with automatic processing of "squeezed" files.

     *  List special bulletins, system information, BBS lists, etc.

     *  Chat with sysop.
     
     *  Change user parameters including page and line length, prompt bell, 
        etc.
      
     *  List names of other users on system.

     Before I get into the explanation of the way that PICS is organized, 
     it is important to learn about the prompts that the system gives you 
     when it is waiting for you to type in a command (at subsystem menus). 
     Following that I will try and explain file name wildcards. 

                               SYSTEM PROMPTS

     The system prompt is the line that you see whenever the system is 
     waiting for an input from you at one of the sub-system menus.

     Prompts consist of several components:

     A.   YOUR TIME REMAINING ON THE BBS.
     B.   CURRENT SUBSYSTEM (Message, Files, or Utilities)
     C.   CURRENT MESSAGE AREA OR FILE SECTION.
     D.   LIBRARY NAME (if a library is active under Files subsystem)

     For example:

     32-Files NEWIN [press "?" for menu]>
     ^    ^     ^           
     A.   B.    C.          

     The above line indicates that you have 32 minutes remaining on the 
     system, are currently in the files subsystem, and are logged into the 
     NEWIN area. Should you enter a library, your prompt might look 
     something like the following:
               
     13-Files NEWIN [VECTOR.LBR]>
     ^  ^     ^         ^
     A. B.    C.        D.

     When you are not at one of the subsystem command prompts and the 
     system is expecting you to type in one of several possible commands, 
     you will see something like:
       Enter your command <A><B><C><D><Q><?> >
     Here the possible commands are the letters contained inside the <> 
     symbols. Enter one of these, then a carriage return, and the command 
     will execute. Generally, whenever you see a <Q> the Q may be used to 
     Quit the command presently being executed and return to the previous 
     menu. Using the ? will display an additional line of help for the 
     single letter commands, then re-prompt you for an answer.

                            COMMAND LINE ENTRIES

     A command line entry is what you type in at the command prompt. A 
     general rule is most commands require a single letter followed by 
     a carriage return (CR) or Enter. The exception is where names are 
     required.

     For example: 

     32-Message PC [press "?" for menu]> C;POST;R;S;C
                                        |____________|

                                    The above string will:

     CHANGE AREA; POST AREA; READ MESSAGES; SINCE LAST ON; CONTINUOUSLY

     The delimiter used above was a semi-colon, however a space or a comma 
     is also accepted. (ie. C POST R S C or C,POST,R,S,C will both work).
     The user may ask for help by typing "?" at any prompt. The commands 
     available for that particular area and their meanings will be 
     displayed. All commands are executed when the letter displayed on the 
     menus in angle brackets ("<>") is entered followed by a carriage 
     return (CR).  Usually, a second prompt will be displayed which will 
     indicate what further information is required to complete the 
     operation.

     During most system display operations, PICS will respond to Xon/Xoff 
     control, i.e. when ^S (Xoff) is entered, the display will pause until 
     another key is pressed. Usually this will be ^Q (Xon), but any key 
     except ^C (ETX) or ^S will continue the listing. ^C will stop the 
     listing completely and usually return you to the command prompt.
      

                               FILENAME WILDCARDS

     The use of wildcards in file searchs or selections allows you to use 
     special characters to represent one or more wildcard characters when 
     entering filenames that will be searched for by a program or routine.
     The position of the special character in the file name determines how 
     many wildcard characters will be represented.

     The "*" means any letter or group of letters allowed.
     The "?" means any single letter in this position only. 

     In general, a * entered to the left of the . in the filename will 
     represent up to 8 ? special characters in the name and will match with 
     any characters in the name. A * on the right of the . in the filename 
     will represent up to 3  ?  special characters in the name extent.

     Here is a sample list of filenames to be searched using wildcards.
     NAMES:   FOO1.TXT  FOO2.TXT  FOO3.COM  FRED.TXT  DEAD.COM

     We enter:      Response to special character(s):
     ---------      ---------------------------------
     *.*            expands to ????????.??? and finds ALL file names:
                    FOO1.TXT  FOO2.TXT  FOO3.COM  FRED.TXT  DEAD.COM
     FOO?.*         expands to FOO?.??? and finds file names:
                    FOO1.TXT  FOO2.TXT  FOO3.COM
     FOO*.*         expands to FOO?????.??? and finds file names:
                    FOO1.TXT  FOO2.TXT  FOO3.COM
     FOO?.TXT       FOO1.TXT  FOO2.TXT
     *.COM          expands to ????????.COM and finds file names:
                    FOO3.COM  DEAD.COM
     ?EAD.*         expands to ?EAD.??? and finds file names:
                    FRED.TXT  DEAD.COM
     
     So if you wanted to search for all .APP (Application) files you would 
     enter "*.APP" which means allow anything for the name as long as the 
     extension is APP. you could also have entered "????????.APP". Note 
     that when you use ?'s each one is good for one character only.  

     Now the organization of PICS.

     ====================================================================

                                COMMAND SYSTEMS

     Approximately 40 commands are available to users of PICS to enter and 
     read messages, display directories, transfer files, and control the 
     system configuration.  These commands are grouped into three command 
     subsystems. Within each subsystem is a Menu of commands available.

     Subsystem              Primary Use
     --------               -----------
     Message Subsystem      Enter and read messages to/from other users 
     Files Subsystem        Send and Receive files 
     Utilities Subsystem    Miscellaneous functions

     Here is a detailed explanation of each subsystem:

                              MESSAGE SUBSYSTEM

     This is the Message Subsystem menu. A detailed explanation of each 
     command follows the menu. Remember that the commands are represented 
     in the menu by the <A> notation where the command is the letter inside 
     the <> symbols.


                        PICS - Message Subsystem Menu

======= Functions ========              ==== Other Menus ================

<A>rticles to read                      <F>ile transfer Subsystem
<B>ulletin                              <U>tilities Subsystem
<C>hange message area
<E>nter a message      
<I>nformation for new users
<O>ther systems list
<Q>uick-scan messages
<R>ead messages
<S>can messages
<G>oodbye (logoff)
=========================================================================

     <A>rticles to read
          Will display a menu of Sysop selected articles and allow 
          you to make selections for viewing.
                        
     <B>ulletin
          This command redisplays the Bulletins that are displayed auto-
          matically during each caller login.
      
     <C>hange message area
          PICS supports multiple message areas, i.e. messages are filed in 
          groups by topic.  This effectively shortens the message file for    
          any particular user and makes finding a particular message 
          easier.  After typing "C", enter the name of the desired message 
          area or enter "?" and <RETURN> to get a menu of the message areas 
          available.  If the entry cannot be found, a short version of the 
          menu will be displayed and the system will once again prompt for 
          the message area.  
      
     <E>nter a message
          Until you are validated, this command will automatically enter  
          all messages to the sysop.
      
          Use this command to send a message to another user, the sysop, or 
          to all users (like posting a message on a bulletin board). If you 
          enter only a <RETURN> in response to the "FIRST name" prompt, the 
          message will go to all users.  If you send to a particular person, 
          the system will verify the recipient name.  If the system cannot 
          find the addressee, you will be informed and given the 
          opportunity to try again. At the completion of message entry PICS 
          will ask you if you want the message to be Public (available for 
          all validated users to read) or Private (just addressee [and 
          sysop] can read).
      
          When you leave PICS with the G command, you will be asked if you 
          want to leave a comment (message) to the sysop. If you answer 
          Yes, you will be able to leave a private message addressed to 
          the Sysop before leaving PICS.

          If you have trouble entering your password during login, after 
          the maximum number of tries allowed PICS will enter the message 
          editor and address a message to the Sysop for you with the 
          subject 'Password Problem'. You can then enter the message and 
          explain what problems you were having.     
            
          Otherwise, to send a message to the sysop, enter "SYSOP" as the 
          first name. You will not be prompted for a last name.
      
          During message entry, hitting a Return (carriage return) on a 
          blank line (that is, at the beginning of a line) will activate 
          the message editor. This is the way to end messages or stop 
          during the message to correct mistakes. The following commands 
          are then available (can be displayed by typing "?" at the 
          Message Editor "Command>" prompt):
                                         
      
== Message Entry Commands ==  ============== Editing controls ==============
<C>ontinue message entry      Backspace  Delete previous character
<D>elete line                 RUB (DEL)  Delete previous character
<E>dit a selected line        TAB        Space to next multiple of 5 column
<I>nsert line                 RETURN     Complete line entry
<L>ist current message        CTRL-X     Delete line to left of cursor
<S>ave message to disk        CTRL-A     Move cursor to beginning of line
<Q>uit DON'T save message     CTRL-S     Move cursor one character left
                              CTRL-D     Move cursor one character right
                              CTRL-F     Update line and move cursor to end
                              CTRL-G     Delete character at cursor position

For speed, the edit line is not visibly updated until requested by CTRL-F.
============================================================================

          After using the message editor you will be returned to the 
          subsystem command prompt. Remember, if you want the message 
          recorded, use the <S> command instead of the <Q> command. All 
          other commands will return you to the message editor prompt for 
          further editing.
      
     That completes the explanation for entering messages. Now to return 
     to the rest of the commands available in the Messages subsystem.
      
     <I>nformation for new users
          This short description of the system is displayed the first 
          time you logged in. This command displays it again.
      
     <O>ther systems list
          This is a list of other public Bulletin Board Systems (BBS's) in 
          the local area.
      
     <Q>uick-scan messages
          After typing "Q", the system will prompt for the starting message 
          number.  If the message number cannot be found, the system will   
          start with next sequential message unless the requested number is 
          outside the range displayed in brackets.  In that case, the 
          system will start the scan with the next message after the 
          highest message read the last time you logged in.  For example, 
          if you call on Saturday and the highest message you read was 342, 
          when you call in on Tuesday and enter a <RETURN> in response to 
          the "Start" prompt, the system will start the display with the 
          next available message after 342. The message number and topic of 
          messages from the starting number until the last message will 
          then be displayed.  If the message is addressed to you privately, 
          a "*" will be displayed. If the message is public, a ":" will be 
          displayed between the number and the topic.
      
     <R>ead messages

          After entering "R", this command will prompt for the following 
          information about which messages to read. All commands are just 
          for the Message Area you are currently in.
            
          Read Search Option <A><F><T><N><S><Q> [press "?" for menu]>

               The options translate as follows:

               <A>ll                   messages in this area
               <F>rom you              previously entered messages
               <T>o you 
               <N>umeric               similar to ALL but you are 
                                       prompted for the starting number
               <S>ince your last call  PICS remembers the number of the
                                       last message you read.
               <Q>uit                  return to subsystem command prompt
                                       without reading any messages.

          After entering "A, F, T, N, or S" the system will respond by 
          displaying the header of the first requested message and then 
          prompt you with:
          
          Read <Y><N><C><Q><P><R> [press "?" for menu]>

          These commands translate as follows: 
      
               <Y>es          display text of message
               <N>o           skip to next message
               <C>ontinuous   displays all messages from here 
                              on with no pauses
               <Q>uit         end message reading and return to subsystem
                              menu prompt.
               <R>eply        to current message even if not 
                              addressed to you
               <P>revious     backup to last message

          If you are the addressee of a message the system will ask you if 
          you wish to reply. Respond with either "Y" or "N". If you reply 
          with "Y" the system will put you into message entry mode with 
          the author and addressee reversed and the subject line will be 
          the same except that the words "Reply to-" will be added. After 
          completion of the message you will be returned to the message 
          read mode where you left off.

          Whether you replied or not, you will be asked if you wish to 
          delete the message addressed to you.
                 
          If you are the author of the message or the receiver of a 
          privately addressed message, the system will ask if you want to 
          delete it.  Respond with either "Y" to delete the message or with 
          "N" to retain the message on the system.
      
          If the message is not the last message, the system will ask if 
          you want to read the next sequential message on file.  Respond 
          "Y" to continue with the reading, or with "N" to skip the 
          message.  
      
     <S>can messages
          This command is similar to quick-scan.  In addition to the number 
          and topic, the sender and receiver will be displayed.
      
     <G>oodbye (logoff)
          This command is available in all subsystems. It is used to 
          terminate the remote session. You will be given the opportunity 
          to enter any comments or questions to the sysop. When this is 
          done, the system will disconnect.
      
     <F>iles Subsystem
          This command transfers you to the Files subsystem and gives you 
          the command prompt for that subsystem.
            
     <U>tilities Subsystem
          This command transfers you to the Utilities subsystem and gives 
          you the command prompt for that subsystem.
                  

                               FILES SUBSYSTEM

     The following  menu lists the commands available in the files 
     subsystem.  Subsequent paragraphs describe each command in more 
     detail.

                     PICS - File Transfer Subsystem Menu

==================== Functions =====================   === Other Menus ===

<C>hange file area            <L>ibrary entry/exit     <M>essage Subsystem
<D>irectory of files          <N>ewin list             <U>tilities Subsystem
<F>ind File(s)
<Z>Filesize/Time display
<G>oodbye (logoff)

<R>eceive file using Xmodem protocol               (you --> PICS) (upload)
     (with automatic 1k protocol checking by PICS)
<RB> Receive Batch (more than 1 file. requires 1K protocol.)

<S>end file using Xmodem protocol-regular          (PICS --> you) (download)
<SK> Send Xmodem 1K protocol                       (PICS --> you)
<SB> Send Batch (more than 1 file. requires 1K protocol.)

<T>ype ASCII or squeezed file (Xon/Xoff supported)
=============================================================================

     <C>hange file section
          When you first log in, you will be placed in the "LOGIN" files 
          section.  (In the Message subsystem, there were Message Areas;
          here we switch the terminology to Sections.) To access other 
          files sections in the system, use this command.  After typing 
          "C", enter the name of the desired file section or enter "?" to 
          get a menu of the file sections available.  If the section name 
          cannot be found, you will be shown a list of the section names 
          available and the system will once again prompt for the section 
          name.  
                                              
          If you are in a library file (see next description) when this 
          command is entered, the library will be closed before the system 
          prompts for the new section.
            
     <D>irectory of files
          This command alphabetically displays the directory of files for 
          the current section. If you are in a library, only those files in 
          the library will be displayed; otherwise, the Section directory 
          will be displayed. The file size will also be displayed according 
          to the current filesize mode (see filesize description).
            
     <F>ind File(s)
          This command allows you to search through all available file 
          sections to locate a particular file or file group. Standard CP/M 
          wildcards are accepted.
      
     <Z>Filesize/Time display
          Initially, the file sizes in the directory display will be shown    
          in "k" (1024 bytes).  The system can also display file sizes in
          minutes and seconds of transfer time (based on the current modem
          speed).  Each time this command is entered, the system will
          alternate between these two methods.
      
     <R>eceive file using Xmodem protocol  (you --> PICS) (UPLOAD)

          This command allows PICS to receive a file from your computer. 
          The system will automatically respond to both CRC and checksum 
          error detection methods. Also PICS now supports the 1k protocol 
          and will test to see if you are using it to send the file. Files 
          will be received in a private area for Sysop approval before 
          being released for others to download (PICS sending) to their 
          computers.
           
          If you are enrolled in a conference section, PICS will write 
          files that you send to the conference section directly. They 
          will be visible immediately for other conference members to 
          download. PICS will tell you where the file will be written 
          before you send it.
      
          To use this command you should first give the <R> command and 
          then the file name as requested. PICS will tell you how much 
          disk space is available and that it is Ready to Receive. If 
          there isn't enough for the file that you are sending, type 
          Control X until PICS aborts the receive mode and returns to the 
          command mode. If everything is OK at the "Ready To Receive" 
          prompt you should start the send process. After the file 
          transfer has completed successfully, PICS will ask for a Section 
          designation and short description of the file. This description 
          will be shown by the <N>ewin command after the sysop reviews the 
          file. Uploads are always welcome.
                 
          If there is a need to stop the transfer you may enter Control X 
          commands from your computer and PICS will abort. 

     <RB> Receive Batch - Multiple files - automatic naming

          This command is essentially the same as the <R> command with the 
          following differences. The system will receive a group of files 
          automatically without your entering each file name. To use this 
          command your computer must have YMODEM or KMD batch sending 
          protocol. The system will receive all files until termination or 
          completion of the batch operation and will then ask for Section 
          designations and short descriptions for all files received. 
          NOTE: Some versions of Modem 7xx programs and all versions of 
          MEX programs have an old batch protocol that will not work with 
          PICS.
                             
     <S>end file using Xmodem protocol-regular    (PICS --> you) (download)

          The Xmodem protocol is an essentially error free file transfer 
          method that allows two computers to "check" each block of 
          characters that are sent to insure accurate transfer.  Most 
          terminal communications programs (that you are using on your 
          computer) have the capability of using this protocol. If you 
          also have the capability of receiving 1K blocks, PICS can be 
          told to send the file(s) that way (using the SK command).
                       
          Use this command to send single files from PICS to your 
          computer.  After entering "S", you will be prompted to enter the 
          file name of the program you want sent to your computer.  If the 
          system can find the file in the current area, it will display 
          the transfer time and then the message "Ready to send..."
                                   
          PICS will attempt to send the file using the CRC method of error 
          checking. If this fails after a number of tries, PICS will switch 
          over to the Checksum method and try again.
            
          When the file transfer is complete, the system will return to the 
          Files subsystem prompt.
      
     <SK> Send Xmodem 1K protocol                       (PICS --> you)
          This command works exactly like the <S> command with the 
          following differences. Normal XMODEM file transfers send 128 
          bytes per block. In order to speed up the transfer process some 
          systems support a 1024 bytes (1k) block format known by various
          names such as Ymodem, KMD or just 1K. This protocol works well 
          and saves time, but when a bad phone line forces a block to be 
          sent over again due to an error, the efficiency decreases fast. 
          PICS will automatically switch back to standard 128 byte blocks 
          if too many errors are detected. Your computer will also 
          automatically respond to the switch.
           
     <SB> Send Batch - Automatic multiple file transfer.
          Using this command requires that your communications program  
          support Ymodem or KMD batch and 1K block size protocol and CRC 
          error detection. The SB command is the reverse of the RB command 
          in that it will send multiple files from the BBS to your 
          computer. However in order to use this you must have a YMODEM 
          (batch receive) protocol on your computer. To use this command, 
          enter it and when the system asks for the filenames, type the 
          names separated by a semicolon, a comma, or a space. This 
          command also supports CP/M style WILDCARDS. Read the section on 
          wildcards for more information.
                             
     <T>ype ASCII or squeezed file (Xon/Xoff supported)
          An ASCII,Text (squeezed or not) file is one that contains 
          readable characters rather than machine code. This command may 
          be used to display the contents of these files. PICS will ask 
          you if you want page breaks which will pause the display at the 
          number of lines per page as set in your user parameters. 
          Xon/Xoff may also be used as described in the Key Entries 
          section to pause the display.
                 
          NOTE: This command may be used to transfer readable files even 
          though your computer does not support the Xmodem protocol. If 
          your machine has a feature to 'Capture' what is printed on your 
          screen, you can use it to get the file transfered.

     <L>ibrary entry/exit

          Libraries are used to place a group of related files in a single 
          file known as a Library file. For example, a single library 
          might contain source code, object or executable code, and 
          documentation for a particular system.  Such a library is 
          actually a single file which contains an invisible "directory" 
          followed by the files.  The "directory" is used to keep track of 
          the files inside the library.
                       
          In order to simplify library usage on this system, the "L" 
          command may be used to "enter" a library.  When this is done, the 
          system will prompt for the library file name and then attempt to 
          open the library for use.  If successful, all subsequent Files 
          subsystem commands will relate to the files within the library.  
          The other files in the present File Section will not be 
          accessible. If not, an appropriate error message will be issued.
            
          If you are already in a library, entering "L" will cause the         
          system to close the library and return to normal display of the 
          files in the present File Section.
      
     <N>ewin list
          This command displays, from the newest to the oldest, files that 
          have been uploaded to this system. The three line format is as 
          follows:
                 
     1.  FILENAME.EXT   FILE SECTION   UPLOAD DATE    NAME OF UPLOADER
     2.  TIMES DOWNLOADED           LAST DOWNLOAD DATE
     3.  [----------------75 CHARACTER DESCRIPTION OF FILE----------------] 

          The File Section name is entered by the sender to tell the sysop 
          where the file should eventually be stored. If a file is listed 
          as "TELECOM SECTION", after upload it will stay in the NEWIN 
          section for a while and then be moved to the GAMES section. (The 
          Section names here are only an example, and may not exist on all 
          systems.)
                 
          If you are presently in the NEWIN file section, all uploaded file 
          entries (all sections) will be displayed for you. However, if 
          you change to a different file section and use the <N>ewin 
          command, only the uploaded files marked for that file section 
          will be displayed. All other sections will be ignored. This is 
          so you don't have to wade through all the other section files 
          just to see the one you're interested in. However if you are 
          actually in the NEWIN section and use the <N>ewin command you 
          will see all files uploaded regardless of their section 
          designation.
                        
          Additionally, there is a file search option in the <N>ewin list 
          command. This will keep you from having to scan the entire newin 
          list just to get a description of a particular file. This search 
          option supports wildcards but will stop searching at the first 
          entry that matches the search arguments.
      
     <G>oodbye (logoff)
          This command is available in all subsystems. It is used to 
          terminate the remote session. You will be given the opportunity 
          to enter any comments or questions to the sysop. When this is 
          done, the system will disconnect.
      
     <U>tilities Subsystem
          This command transfers you to the Utilities subsystem.
      
     <M>essage Subsystem
          This command transfers you to the Messages subsystem.
      

                              UTILITIES SUBSYSTEM

     The following menu lists the commands available in the utilities 
     subsystem.  Subsequent paragraphs describe each command in more 
     detail.
      
                        PICS - Utility Subsystem Menu

================== Functions ==================     ==== Other Menus ========

<A>lter user parameters       <T>ime and date       <F>ile Transfer Subsystem
<C>hat with sysop             <U>ser list           <M>essage Subsystem
<S>ystem use statistics       <Y>our statistics

<G>oodbye (logoff)
=============================================================================

     <A>lter user parameters
          This command allows you to set several parameters as listed in  
          the following menu.  Subsequent paragraphs describe each command.
            
                         Alter User Parameter Menu

=============================================================================

<B>ell after prompt on/off    <L>ines per page         <P>assword change
<N>ulls sent after C/R        <S>hift lock
<Q>uit

All  changes you make will be recorded in your user record and retained.
=============================================================================

               <B>ell after prompt on/off
                    This command turns on and off the bell (or beep) used to 
                    indicate that the system is ready for your input.
                  
               <L>ines per page
                    To improve the readability of long displays, PICS will 
                    pause after a specified number of lines, waiting for a 
                    key to be pressed before proceeding. Use this 
                    parameter to match the number of lines displayed to 
                    your screen size.  If you specify "99" as the line 
                    count, PICS will not pause. At this setting, the 
                    normal pause between messages is also suppressed and 
                    PICS will continue until all messages are displayed or 
                    stopped by CONTROL-S (XOFF) OR CONTROL-C (ABORT).
                           
               <N>ulls sent after C/R
           
                    Nulls are sent after a carriage return to allow time 
                    for your machine to catch up before any printable 
                    characters are sent. Normally this value is set to "0" 
                    for CRT (display) terminals, and from 0-9 (try 2) for 
                    hardcopy printing terminals.  If your display loses 
                    characters at the beginning of the line, try 
                    increasing this parameter.
                     
                    When you first logged in, you were asked for the 
                    number of nulls you needed and whether or not your 
                    system could display lower case.  If your system 
                    changes or you need to change this value for any other 
                    reason, use this command.
                                      
              <P>assword change
                    When this command is executed, the system will ask for 
                    your current password.  If it is entered correctly, 
                    you will be asked for a new password in a fashion 
                    similar to when you first logged into the system.
                           
              <S>hift lock (toggle)
                    Some terminals do not know what to do with lower case 
                    letters. If you respond "Y", lower case will be sent 
                    normally. If you answer "N", lower case letters will 
                    be converted to upper case  before being sent to your 
                    system.

              This completes the Change User Params menu explanation.
         
          
     <C>hat with Sysop
          During certain hours, the sysop may be available to chat.  When 
          this command is entered, the system will try to summon the sysop 
          (if during the chat period).  If the sysop is available, you 
          will be notified and a two way conversation may begin.  If the 
          sysop is not available or if the current time is outside the 
          hours to chat, you will be given the opportunity to leave a 
          message.
                 
     <S>ystem use statistics
          This command displays a bar chart of the percent of system usage 
          by hour.  From the information on this chart, you can plan your 
          calls for times when the system is less busy.
      
     <T>ime and date
          This command will display the current time and date, the amount 
          of time spent on the system today, and the amount of time 
          remaining today.
      
     <U>ser list
          Alphabetically list all the validated users on the system. This 
          command may be used to check the spelling of a user to whom you 
          wish to send a message.  You may start the list with any name or 
          part of name by entering one or more letters at the appropriate 
          prompt.
      
     <Y>our statistics
          This command displays the login statistics that you saw when you 
          first logged in. 
      
               Login Time/Date
               User Name
               Caller Number
               Access Time Today
               Access Time Total
               Last On System Time/Date
               Last High Message
               High Message Now
               Downloads
               Uploads

     <G>oodbye (logoff)
          This command is available in all subsystems. It is used to 
          terminate the remote session. You will be given the opportunity 
          to enter any comments or questions to the sysop. When this is 
          done, the system will disconnect.
      
     <F>iles Subsystem
          This command transfers you to the Files subsystem.
      
     <M>essage Subsystem
          This command transfers you to the Messages subsystem.

     ==================================================================

     This completes the organization of PICS, the detailed menu and 
     command descriptions. The following is general information for you 
     to understand how PICS works.

     After the usual name and password verification, you will be logged 
     into the "POST" message area. This is the subsystem and Area that all 
     callers start from. You will be notified of any pending personal mail 
     sent to you in this area and if there are messages waiting in other 
     areas.  Messages you sent in this Area which have not been deleted 
     will also be displayed. You may stay in this subsystem and read 
     messages etc. or go to any other subsystem from this point. If you are 
     a new caller and have not yet been validated by the sysop you may find 
     that there are a limited number of Message Areas and File Sections 
     available. Be patient, there are probably many more that will be 
     available when you're validated.

     While you are on the system, PICS is watching the amount of time that 
     you have left on the system (the first number in all subsystem 
     prompts). If you use all of your allowed time, PICS will notify you 
     two minutes before hanging up. Since the time allowed on the system 
     is for each 24 hour day (midnight to midnight) you will not be 
     allowed to log in again until the next day.

     While PICS is waiting for you to type in your response to a prompt, it 
     is watching the time. If you do not type something within a reasonable 
     time PICS will think that you have gone to sleep and will print a 
     message on your screen,  ++ Input timed out ++, and will hang up.

     There are a number of Sysop controlled options in the PICS system, and 
     some that are not optional. I'll try to describe some of them so you 
     will recognize what's happening.

     PICS constantly watches the amount of disk space free on the Sysop's 
     system. If the disks start to fill up, PICS automatically goes into a 
     more and more restrictive mode of operation as the disks fill up. You 
     will be notified that there is a problem and that is why you are not 
     being allowed to do something that you were previously able to do.

     If the Sysop doesn't want to be bothered, he has the ability to turn 
     off the Chat function completely. If you are told when requesting a 
     Chat that the function is not available this may be the case. 

     If the system is extemely busy the Sysop has options to limit the 
     number of lines allowed during each message entry (normally not 
     limited). He may also limit 300 baud callers from calling the system 
     during certain extremely busy hours.

     Most PICS systems will offer additional time online to you if you call 
     during the off peak hours. Typically, 20 to 30 additional minutes are 
     added to your allowed time in off-peak hours. This will show up in the 
     subsystem command prompt.


      

     I hope that you enjoy PICS and find it easy to use. This manual was 
     written so that new users could get up to speed quickly and 
     experienced users would have a reference. 


 was 
     written so that new users could get up to speed quickly and 
     experienced use