(*****************************************************************************)
(*                                                                           *)
(*            PICSPC - Pascal Integrated Communications System               *)
(*                           IBM PC  Version                                 *)
(*                     Copyright (c) 1986, 1987 by                           *)
(*                           Les Archambault                                 *)
(*                                                                           *)
(*                      All commercial rights reserved.                      *)
(*                                                                           *)
(*    This program is based on ROS Vers 3.4 by Steve Fox. It is released     *)
(*    into the public domain for private use only. Additional thanks to      *)
(*    Irv Hoff whose 1k protocal in KMD was invaluable in writing the        *)
(*    Turbo Pascal routines. Special thanks to Lindsay Jones, Eric Daniel,   *)
(*    Freeman Bradford and John Van Hengel for beta testing and support.     *)
(*                                                                           *)
(*****************************************************************************)

2/10/87

This document is taken from the file PICSINST.MAN for the CP/M version and
has been edited for this version. Please follow the steps as outlines and
you should have no trouble getting a system running in a short time.

It is very important that you have the statement "FILES=25" (or more) in
your CONFIG.SYS file. If not PICSPC will crash with a 'too many files open'
message.


STEP 1.
EDIT THE SYSTEM MESSAGES FILE
-----------------------------

         The system message file SYSMSG.TXT (included in the distribution
        package) should be edited for your particular system. This file
        contains the  Welcome Message and Bulletins as well as
        other messages and the menus for PICSPC. PICSPC can process
        SYSMSG.TXT files which have been created by text editors - such as
        WordStar - which use the high bit.  When PICSPC is started, it
        attempts to open SYSMSG.BB# which is a random access file.  If
        PICSPC finds this file, it will be used. If not, PICSPC will create
        it from SYSMSG.TXT. This is what will happen the first time you run
        PICSPC. The lines in SYSMSG.TXT should not be longer than 79
        characters, or PICSPC will cut them off and notify you during
        creation of the SYSMSG.BB# file.

        Whenever you update the SYSMSG.TXT file, delete the file SYSMSG.BB#,
        (if it exists). PICSPC will automatically make a new SYSMSG.BB# file
        from your edited text file.

        Caution:
        When used with certain text editors, SYSMSG.TXT will not contain
        a terminating End-Of-File marker (^Z) if the number of characters
        in the file is a multiple of 128.  Should this happen, PICSPC will
        not properly terminate the creation of SYSMSG.BB# and a disk full
        error will eventually occur.  As a work-around, add or delete one
        or more characters from SYSMSG.TXT, delete SYSMSG.BB#, and restart
        PICSPC.  This extreme situation obviously does not occur often. You
        should also be careful that your editor expands all tabs to the
        proper number of spaces instead of just one character (Control I).
        - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        Although not a requirement for installing PICSPC you may edit the
        sample file BADNAMES.LST.  This file is read during Login of each
        caller. The first and last names are checked for reserved names as
        follows:
           Each line in the BADNAMES.LST file is read in separately.
           The first and last names are then checked to see if either of
           them is a sub-string (contained within) the line read. Then
           the line read is checked to see if it is a sub-string of either
           the first or last names.
        By selection of how you write each of the lines in the BADNAMES.LST
        file, ie. several names together, or a single word on a line, you
        can manage the way the program searches for reserved names.
        Since PICSPC converts both names to upper case, be sure to use upper
        case characters when editing the file.
===========================================================================

STEP 2.
ESTABLISHING THE SYSTEM ORGANIZATION AND SET UP
-----------------------------------------------

        A program named PCSETUP.COM has been included in the PICSPC
        distribution package. It will create the System Organization file
        named SECTION.BB#. In this new file will be minimum required message
        areas and file sections as discussed above. Later, the same
        program can be used to edit and add entries as desired. Initially
        there are no conferences or Articles provided, nor are they needed
        to get the system running. I recommend that you use the minimum
        organization provided by the setup program until the system is up
        and running.

        The security of a computer system is of paramount importance when
        that system is readily available through the telephone system.

        To make PICSPC robust enough to withstand both incorrect entries
        and malicious attacks against the system, a simple but effective
        method is used: an access level, ranging from 0 to 255, is
        assigned to each user. The Message Areas and File Areas (which are
        accessed by name) are also assigned an access level. Users are
        able to gain access to any named File Section or Message Area if
        it's access level is less than or equal to his.

        The exception to this rule is Conferences. Users can gain access
        to a conference if their access level is higher than the level of
        the conference, but usually the conferences are set high enough so
        that only the Sysop and assistants can access it this way. There
        are seven flags contained in each user record. The Sysop may set
        these flags from the Sysop subsystem edit user command. If the
        flag for a particular conference is set, the user has access to
        that conference regardless of his access level, or the access
        level for the conference. When a user record is first created,
        none of the falgs is set.

        The recommended levels of User access are defined as follows. (You
        should follow this guide when setting up access levels for the
        named Message Areas and File Sections described below.)

        0-9       Twit - will be logged off immediately
        10-19     Unvalidated user - limited message and files access
        20-249    Normal user - full message and files access
        250-254   Alternate sysops
        255       Sysop


        The PICSPC system consists of four sub-systems:

          1. The Messages Sub-System.
          2. The Files Sub-System.
          3. The Utilities Sub-System.
          4. The Sysop Sub-System.


        1. THE MESSAGE SUB-SYSTEM
        -------------------------
        Consists of named 'MESSAGE AREAS' where callers can read and leave
        messages to each other. Each 'Message Area' and is assigned a
        minimum user access level by the sysop during creation in the
        PCSETUP program. Message area management is done inside PICSPC and
        therefore there is no separate file or sub-directory for the
        different areas. All messages are stored in the same file.

        The following are the minumum number of message areas that PICSPC
        requires, and their names. PICSPC makes these for you the first
        time that you run PCSETUP.COM:

        POST      This  is the MESSAGE AREA every user 'sees'  initially.
                  The access level of this area will be set to zero.

        SYSTEM    This MESSAGE AREA is special since ALL messages
                  (including those that have been erased) will be
                  visible.  IT IS IMPORTANT that the access level of this
                  area be left high enough that normal users do not have
                  access.  To avoid potential problems, the access level
                  for this area this area will be set at 250.

        Also located with the Message Area sub-system is the Articles
        feature. The user is shown the names of any ASCII text files that
        you have placed on disk. He may read these from the Arcicles sub-
        menu in the Messages sub-system. The PCSETUP.COM program is used
        to integrate the titles into the menus. Then you place the files
        in the Articles sub-directory on the disk that you specified during
        creation.

        2. THE FILES SUB-SYSTEM
        -----------------------
        The FILES sub-system is a group of named 'FILE SECTIONS' where
        files available for distribution (download) and receipt (upload)
        are kept. Access to these Sections (actual sub-directories on your
        disk drives) is controlled by the minimum user access level you
        assign during creation with the PCSETUP.COM program. The sub-direc-
        tories are created by PICSPC on the drive that you specified.
        Please note that when you remove 'File Sections' with PCSETUP.COM
        the sub-directory (if already created) will not be erased, but
        users will no longer be able to access the files.

        The following are the minimum number of 'File Sections' required
        by PICSPC, and their names. PICSPC makes these for you when you
        first run PCSETUP.COM:

        SYSTEM    This FILE SECTION is the location for all of the PICSPC
                  system and data files. Access to this section is for the
                  sysop and his assistants only. Consequently PICSPC sets
                  the access level to 250 for this section.

        LOGIN     This is the FILE SECTION every user 'sees' initially.
                  The access level of this area is zero.

        NEWIN     This is the FILE SECTION into which uploads will be
                  placed.  The access level of this area is set to
                  20, the default access level for validated users.


        There is no limit to the number of MESSAGE AREAS, FILE
        SECTIONS and ARTICLES on the system, but remember that the names
        and descriptions of these will be stored in memory and will
        reduce the amount of memory available for other features.


        3. & 4. THE UTILITIES AND SYSOP SUB-SYSTEMS
        -------------------------------------------
        The Utilities and Sysop sub-sections require no special setup.

        =================================================================

        After completing the setup procedure, the following files should
        be moved to the Drive (and sub-directory if used) where your PICSPC
        system will reside permenently.

               PICSPC.COM
               PICSPC.000 - PICSPC.003
               SECTION.BB#
               SYSMSG.TXT

==========================================================================

STEP 3.
RUN PICSPC TO CREATE NEW FILES AND LOGIN AS SYSOP
-------------------------------------------------

        The first time PICSPC is run, it will automatically create all the
        data files that it needs on the same drive (sub-directory) as the
        PICSPC object files, and will announce that it is doing so.
        If successful the screen will clear and start randomly moving the
        cursor around. This is the normal idle state for PICSPC. At this
        time PICSPC is waiting for:

          1) A signal from the modem indicating a remote user call.
          2) a command from the console indicating a local user. (^L)
          3) a command from the console to show system status. (^J)

        Enter a CONTROL L at the sysop console (telling PICSPC that you want
        to use the system locally).  After the "FIRST name:" prompt
        appears, enter the name "SYSOP."  Do NOT use your first and last
        name. Not finding SYSOP, the system will prompt for a password -
        enter one of your choice.  You are now logged into the system as
        the Sysop with an access level of 255 (the max).  If you want to
        be on the system with your name, re-sign in after login as Sysop.
        This will allow you to send and receive messages as either Sysop
        or using your real name.

        C A U T I O N !!!
        ----------------------------------------------------------------
        It is VERY IMPORTANT that you log in as sysop before putting the
        system up for others to use.  There are folks out there who will
        try to log in as sysop.  If you have not set your password, they
        will set it for you and will consequently have full sysop level
        access.

        If, for any reason, you leave the PICSPC program abnormally before
        completing the first login as SYSOP, newly created files will be
        empty and cause a program crash the next time you try and bring
        it up. You must go back and delete all of the newly created .BB#
        files, except for SECTION.BB# and SYSMSG.BB#. Then restart PICSPC
        again.
        ----------------------------------------------------------------

        Files that PICSPC has created and will use in the future:

        MESSAGE.BB#      The text of messages in the message file.
        SUMMARY.BB#      Message headers and pointers to the text in
                         the MESSAGE.BB# file.
        USERDAT.BB#      The user file random record data file.
        USERIDX.BB#      The Turbo Access index to USERDAT.BB#.
        SECTION.BB#      The system organization random record file.
        LOG.BB#          Coded log of system use.
        STATS.BB#        Coded record of system usage by time & date.
        NEWIN.BB#        Records of Uploads & info about them.
        SYSMSG.BB#       Random record file made from SYSMSG.TXT file.

        Other than the SYSMSG.TXT file, these files are not meant to be
        edited by the sysop with a text editor.

        PICSPC can create text files from the Messages and Log files
        when the Audit feature is used by the Sysop. This is
        discussed in detail in the PICSTO.MAN, Theory of Operations
        manual. In this way, you have the ability to generate a text file
        from the random files shown above. These files can be used to
        keep a record of system activity.

       If you receive the message "Modem Initialization Problem.. press
       any key to continue", it means that your modem has not responded
       properly, is not on, or your modem initialization string is not
       correct. You may still use the program locally, but no modem
       communications are possible until the problem is fixed.

        Les Archambault
