{PPCOV2F.INC}
{ PICSPC  Pascal Integrated Communications System module}
{ 3/6/87 IBM PC VERS 1.1 by Les Archambault}

overlay procedure validate_user;
{ Change user access time and level to 'validated' status }
  var
    temp_user_loc: integer;
    ed_fn: firstname;
    ed_ln: lastname;
    key: StrName;
    temp_user_rec: user_list;
  begin
    get_name(ed_fn, ed_ln,' ');
    key := pad(ed_ln, len_ln) + pad(ed_fn, len_fn);
    FindKey(IdxF, temp_user_loc, key);
    if OK then GetRec(DatF, temp_user_loc, temp_user_rec)
    else writeln(USR, 'Name not found.');
    if OK and (temp_user_rec.access < user_rec.access) and
              (ask('Validate '+temp_user_rec.fn+' '+temp_user_rec.ln))
      then
        begin
          temp_user_rec.access := val_acc;
          temp_user_rec.limit  := val_time;
          PutRec(DatF, temp_user_loc, temp_user_rec);
          writeln(USR, temp_user_rec.fn, ' ', temp_user_rec.ln, ' validated.')
        end
  end;

overlay procedure delete_user;
{ Delete user from file }
  var
    i, temp_user_loc: integer;
    del_fn: firstname;
    del_ln: lastname;
    key: StrName;
    temp_user_rec: user_list;
  begin
    get_name(del_fn, del_ln,' ');
    key := pad(del_ln, len_ln) + pad(del_fn, len_fn);
    FindKey(IdxF, temp_user_loc, key);
    if OK then
      begin
        GetRec(DatF, temp_user_loc, temp_user_rec);
        if temp_user_rec.access < user_rec.access
          then if ask('Delete') then
            begin
              DeleteKey(IdxF, temp_user_loc, key);
              if OK then
                begin
                  DeleteRec(DatF, temp_user_loc);
                  writeln(USR, key, ' deleted.');
                  writeln(USR, 'Revising message summary file.');
                  for i := 1 to pred(FileSize(summ_file)) do
                    begin        { Delete messages pertaining to user }
                      seek(summ_file, i);
                      read(summ_file, summ_rec);
                      if ((summ_rec.user_to = temp_user_loc)
                        or (summ_rec.user_from = temp_user_loc)) then
                           begin
                             if summ_rec.user_to=temp_user_loc then
                             summ_rec.user_to:=-1;
                             if summ_rec.user_from=temp_user_loc then
                               summ_rec.user_from:=-1;
                              mesg_delete;
                           end;
                    end;
                  {now clear newin file references}
                  Writeln(usr,'Revising Newin file.');
                  seek(nwin_file,0);
                  repeat
                    {$I-} read(nwin_file,nwin_rec); {$I+}
                    If IOresult=0 then
                      begin
                        if nwin_rec.user=temp_user_loc then
                          begin
                            nwin_rec.user:=0;
                            write(nwin_file,nwin_rec);
                          end;
                      end;
                  until Eof(nwin_file);
                  {now finally, the log file}
                  writeln(usr,'Revising the Log file.');
                  seek(logr_file,0);
                  repeat
                    {$I-} read(logr_file,logr_rec); {$I+}
                    If IOresult=0 then
                      begin
                        if logr_rec.user=temp_user_loc then
                          begin
                            logr_rec.user:=0;
                            write(logr_file,logr_rec);
                          end;
                      end;
                  until EOF(logr_file);
                end; {OK  - revising files}
            end;  { wants to delete}
      end   {key found}
    else writeln(USR, 'Name not found.')
  end;       {delete user}

overlay procedure edit_user;
{ Display and edit user record }
  var
    i,user_num,num: integer;
    ed_fn: firstname;
    ed_ln: lastname;
    key: StrName;
    temp_user_rec: user_list;
    found:boolean;

  procedure display_user;
    var
      disp_case, disp_nois: str3;
      str: StrTAD;
    begin
      with temp_user_rec do
        begin
          writeln(usr); writeln(usr);
          writeln(USR, '   Name      : ', fn, ' ', ln);
          writeln(USR, '1  Computer  : ', ad);
          writeln(USR, '2  City      : ', cy);
          writeln(USR, '3  State     : ', st);
          writeln(USR, '4  Phone     : ', ph);
          writeln(USR, '5  Password  : ', pw);
          writeln(USR, '6  Acc. level: ', access);
          writeln(USR, '7  Time Limit: ', limit);
          writeln(USR, '8  Nulls     : ', nulls);
          if shift_lock
            then disp_case := 'ON'
            else disp_case := 'OFF';
          writeln(USR, '9  Shift lock: ', disp_case);
          if noisy
            then disp_nois := 'ON'
            else disp_nois := 'OFF';
          writeln(USR, '10 Bell     : ', disp_nois);
          write(USR, '11 Conferences: ');
          found:=false;
          for i:=1 to 7 do
            begin
              if test_bit(conf_flags,i) then
                 begin
                   write(usr,i,' ');  found:=true;
                 end;
            end;
          if not found then write(usr,'None');
          writeln(usr);
          write(USR, '12 Columns   : ', columns:6,' ':15,'19 Allow downloads: ');
          if test_bit(flags,1) then writeln(usr,' No') else writeln(usr,'Yes');
          write(USR, '13 Lines     : ', lines:6,' ':15,'20 Allow private msgs: ');
          if test_bit(flags,2) then writeln(usr,' No') else writeln(usr,'Yes');
          str:=intstr(laston[4],2)+'/'+intstr(laston[3],2)+'/'+intstr(laston[5],2);
          write(USR, '   Last on   : ', str,' ':13,'21 Allow public msgs: ');
          if test_bit(flags,3) then writeln(usr,' No') else writeln(usr,'Yes');
          write(USR, '14 On today  : ', time_today:6,' ':15,'22 Allow any msgs: ');
          if test_bit(flags,4) then writeln(usr,' No') else writeln(usr,'Yes');
          write(USR, '15 On total  : ', time_total:6,' ':15,'23 Exempt User purge: ');
          if test_bit(flags,5) then writeln(usr,'Yes') else writeln(usr,' No');
          writeln(USR, '16 Last high : ', lasthi:6);
          writeln(USR, '17 Uploads   : ', upload:6);
          writeln(USR, '18 Downloads : ', download:6);
          writeln(usr);
        end;
    end;

  begin { edit_user }
    get_name(ed_fn, ed_ln,' ');
    key := pad(ed_ln, len_ln) + pad(ed_fn, len_fn);
    SearchKey(IdxF, user_num, key);
    if OK
      then
        begin
          if user_num = user_loc
            then temp_user_rec := user_rec
            else GetRec(DatF, user_num, temp_user_rec);
          if (temp_user_rec.access <= user_rec.access) or (not remote_copy)  { Only edit users <= self }
            then
              begin
                repeat
                  display_user;
                  num:=strint(prompt('Number to change..[ 0 to abort, 99 to record] ',2,'EL'));
                  if (num<>0) and (num<>99) then
                    begin
                      if num<13 then change_user_params_A(num,temp_user_rec);
                      if num>12 then change_user_params_B(num,temp_user_rec);
                    end;
                until (num=0) or (num=99);
                if num<>0 then
                  begin
                    if user_num = user_loc then
                      begin
                        if not remote_copy then
                          if Ask('Record new permenant record') then
                            begin
                              PutRec(DatF,user_num,temp_user_rec);
                              writeln(usr,'Recording updated user record.');
                            end;
                        user_rec := temp_user_rec;
                      end
                    else
                      begin
                        PutRec(DatF,user_num,temp_user_rec);
                        writeln(usr,'Recording updated user record.');
                      end;
                  end;
              end;
        end
      else writeln(USR, 'Name not found.')
  end;

overlay procedure rebuild_index;
{ Rebuild the user index file from the data file.  In addition, this routine
  will recover the data file from certain types of damage. }
  var
    i, previous_rec, count_used, count_unused: integer;
    key: StrName;
    temp_user_rec: user_list;
    temp: file;
  begin
    writeln(USR, 'Rebuilding user index file.');
    writeln(USR, 'User data file in record order:');
    CloseIndex(IdxF);
    Assign(temp, user_indx + ext);
    Erase(temp);
    InitIndex;
    MakeIndex(IdxF, user_indx + ext, len_ln + len_fn, 0);
    previous_rec := -1;
    count_used := 0;
    count_unused := 0;
    with temp_user_rec do
      begin
        for i := 1 to pred(FileLen(DatF)) do
          begin
            GetRec(DatF, i, temp_user_rec);
            if used = 0
              then
                begin
                  key := pad(ln, len_ln) + pad(fn, len_fn);
                  AddKey(IdxF, i, key);
                  if OK
                    then
                      begin
                        count_used := succ(count_used);
                        writeln(USR, i:4, '  ', used:4, '  ', fn, ' ', ln)
                      end
                    else
                      begin
                        used := previous_rec;    { Can't use DeleteRec since }
                        previous_rec := i;       {   we're playing with pointers }
                        PutRec(DatF, i, temp_user_rec);
                        count_unused := succ(count_unused);
                        writeln(USR, i:4, '  ', used:4, '  Duplicate record deleted')
                      end
                end
              else
                begin
                  used := previous_rec;
                  previous_rec := i;
                  PutRec(DatF, i, temp_user_rec);
                  count_unused := succ(count_unused);
                  writeln(USR, i:4, '  ', used:4, '  Free record')
                end
          end
      end;
    GetRec(DatF, 0, temp_user_rec);
    DatF.FirstFree := previous_rec;
    DatF.NumberFree := count_unused;
    PutRec(DatF, 0, temp_user_rec);

{ Normally PICS only closes files between sessions to improve operational
  speed, but since essential data files have just been modified, they will
  be closed and reopened to ensure file integrity. }

    CloseFile(DatF);
    CloseIndex(IdxF);
    OpenFile(DatF, user_data + ext, SizeOf(user_rec));
    OpenIndex(IdxF, user_indx + ext, len_ln + len_fn, 0);
    InitIndex;
    writeln(USR);
    writeln(USR, FileLen(DatF), ' records, ', UsedRecs(DatF), ' users in file.')
  end;

Overlay Procedure Make_Message;
 {makes a message entry from a disk file}
  var
    msg_status: record_status;
    abort:boolean;
    ch: char;
    start,last_line, to_loc,from_loc,x,to_area: integer;
    to_fn,from_fn: firstname;
    to_ln,from_ln: lastname;
    subj: subject;
    key: StrName;
    temp_user_rec: user_list;
    msg_line:message;
    mfile:text;
    mname:filename;
    t:tad_array;
    this:areaptr;
    area:str10;

  begin
    writeln(usr);  ok:=true;
    mname:=prompt('Name of file to put into message',12,'ES');
    if mname<>' ' then
      begin
        Abort:=false;
        Assign(mfile,mname);
        {$I-} Reset(mfile); {$I+}
        if ioresult<>0 then
          begin
            Writeln(usr);
            writeln(usr,'Can Not find file ',mname);
            writeln(usr);
            ok:=false;
          end;
        if ok then
          begin
            Writeln(USR);
            Write(USR, 'From: ', user_rec.fn, ' ', user_rec.ln);
            if (not ask(' OK')) then
              begin
                repeat
                  from_fn:=prompt('From FIRST Name ',len_fn,'ESN');
                  if from_fn='QUIT' then abort:=true
                  else
                  from_ln:=prompt('From LAST Name  ',len_ln,'ESN');
                  if from_ln='QUIT' then abort:=true;
                  if (not abort) then
                    begin
                      key := pad(from_ln, len_ln) + pad(from_fn, len_fn);
                      FindKey(IdxF, from_loc, key);
                      if not OK then
                        begin
                          Writeln(USR, from_fn, ' ', from_ln, ' not known on system.');
                          writeln(usr,'type QUIT to exit .');
                        end;
                    end;
                until ok or abort or (not online);
              end     {get new FROM name}
            else
            from_loc:=user_loc;
            OK:=false;
            if (not abort) then
              begin
                repeat
                  to_fn := prompt('To FIRST name [CR for ALL]', len_fn, 'ESN');
                  if to_fn='QUIT' then abort:=true
                  else
                  if to_fn=' ' then
                    begin
                      to_loc:=0;
                      msg_status:=public;
                      ok:=true;
                    end
                  else
                  if to_fn = 'SYSOP' then to_ln := ''
                  else
                  to_ln := prompt('LAST name', len_ln, 'ESN');
                  if to_ln='QUIT' then abort:=true;
                  if (not OK) and (not abort) then
                    begin
                      key := pad(to_ln, len_ln) + pad(to_fn, len_fn);
                      FindKey(IdxF, to_loc, key);
                      if not OK then
                        begin
                          Writeln(USR, to_fn, ' ', to_ln, ' not known on system.');
                          writeln(usr,'type QUIT to exit .');
                        end;
                    end;
                until (not online) or OK or abort;
                if abort or (not online) then OK:=false;
                if OK then
                  begin
                    subj := prompt('Subject', len_subj, 'EL');
                    if subj='' then subj:='NONE';
                    If to_fn<>' ' then
                      begin
                        if Ask('Make Message PUBLIC') then msg_status:=public
                        else msg_status:=private;
                      end;
                    repeat
                      this:=areabase;
                      area:=prompt('Message Area',12,'ES?M');
                      if (area=' ') or (area='?') then
                        begin
                          Writeln(usr,'Available message Areas:');
                          writeln(usr);
                          while this<>nil do
                            begin
                              writeln(usr,this^.areaname);
                              this:=this^.next;
                            end;
                        end
                      else
                        begin
                          this:=areabase;
                          while (this<>nil) and (area<>this^.areaname) do
                          this:=this^.next;
                        end;
                    until (area=this^.areaname) or (not online);
                    to_area:=this^.area;

                    start:=filesize(mesg_file);    {record msg lines}
                    seek(mesg_file,start);
                    last_line:=0;
                    while (not EOF(mfile)) do
                      begin
                        Readln(mfile,msg_line);
                        write(mesg_file,msg_line);
                        last_line:=succ(last_line);
                      end;
                    close(mfile);

                    GetTAD(t);                 {make summary file record}
                    seek(summ_file, 0);
                    read(summ_file, summ_rec);
                    with summ_rec do
                      begin
                        date      := t;
                        status    := msg_status;
                        area      := to_area;
                        num       := succ(num);
                        num_prev  := 0;
                        num_next  := 0;
                        user_from := from_loc;
                        user_to   := to_loc;
                        subject   := subj;
                        st_rec    := start;
                        size      := last_line;
                      end;
                    seek(summ_file, 0);
                    Write(summ_file, summ_rec);
                    seek(summ_file, filesize(summ_file));  {add new record to end}
                    Write(summ_file, summ_rec);
                    mesg_insert(0);
                    writeln(usr);
                    writeln(usr,'Message built.');
                  end;                {OK second time}
              end;                    {not abort}
          end;                        {OK}
      end;                            {Name<>' '}
  end;                                {make message}

{ end of PPCOV2F.inc}
