; SPORTLIB Control File (Library Management)
; (C) 1988-1991, Augustine Associates
; SPORT Version 1.40
;
; THIS IS A SAMPLE CONTROL FILE FOR DEMONSTRATION PURPOSES ONLY!
;
; <- Semicolon denotes a comment line
;
;
; SPORT Extended Library Utility
;
;
; Library Filing Module   Command:  SPORTLIB L
; =====================
;
; This module allows SPORTLIB to search through the current SFLASH library and,
; based upon key words or phrases located, file a duplicate copy of the SFLASH
; message into the named library.
;
; Libraries are named by the user with a unique filename of 1 to 8 characters.
; They ALWAYS bear the extension ".LIB" which is automatically provided by
; SPORTLIB.  There are two keywords in this control file which configure
; the Library Filing Module:
;
;        libmatch=string,    where "libmatch=" is the keyword and "string"
;                            is the word or phrase to search.
;        libname=filename,   where "libname=" is the keyword and "filename"
;                            is the user-defined name of the library file.
;
; Note that there are NO spaces surrounding the "=" sign and that the order
; of the two keywords must be followed as outlined.  In other words, for
; SPORTLIB to perform its function, the "libmatch=..." must always be followed
; immediately by a "libname=...".  Any change in the order will cause
; SPORTLIB to report an error and discontinue operations.
;
; The "string" to be matched may be up to 40 characters long and is not sen-
; sitive to case.  SPORTLIB, your SFLASH Library and this control file must
; all exist in the same subdirectory.
;
; Here is an example of how to use the Library Filing Module:
;
;libmatch=Augustine Associates
;libname=doc
;libmatch=DOC
;libname=doc
;
; Here's another example of filing library messages by month:
;
;libmatch=Date: Jan
;libname=jan
;libmatch=Date: Feb
;libname=feb
;libmatch=Date: Mar
;libname=mar
;libmatch=Date: Apr
;libname=apr
;libmatch=Date: May
;libname=may
;libmatch=Date: Jun
;libname=jun
;libmatch=Date: Jul
;libname=jul
;libmatch=Date: Aug
;libname=aug
;libmatch=Date: Sep
;libname=sep
;libmatch=Date: Oct
;libname=oct
;libmatch=Date: Nov
;libname=nov
;libmatch=Date: Dec
;libname=dec
;
; And here's the default in case the message doesn't qualify under any match:
;libmatch=:
;libname=general
;
;
; Note that case does not matter.  Also, when this part of SPORLIB is used,
; the match and filing procedure is undertaken by the "first found" method.
; In other words, if a single SFLASH message contains both "Augustine..." and
; "Doc", the first match (Augustine Associates) would be used.
;
; Also note that the "string" to be matched must appear in the first five lines
; of an SFLASH message.  Nothing beyond the first five lines of any message is
; searched.
;
; Since some characters appear in all Flash Message headers, it is possible
; to copy all SFLASH Library messages to a library of your choice by using
; a search string such as ":" (a colon).
;
; You also have a choice of MOVING the Flash Message, or COPYING it.  If you
; choose to MOVE it, then the message will be deleted from your SFLASH
; library.  If you choose to COPY it, the message will remain in your SFLASH
; library.  In either event it, or a copy of it, will be placed in the library
; you specify.   The keywords are MOVE or COPY.  The default condition is COPY
; so it is unecessary to use the keyword unless you so desire.
;
; Uncomment the next keyword line to always MOVE, not COPY, the messages:
;MOVE
;
;
;
; Library Retrieval Mode     Command:  SPORTLIB R libname
; ======================
;
; This option will retrieve messages stored in a library you name ("libname")
; and return them to vacant positions in your SFLASH Library.  Up to 100
; message will be retrieved (or less, depending upon the number of vacant
; positions available in your SFLASH Library).
;
; The original messages in your named library will be retained.
;
;
; Library Manual Mode        Command:  SPORTLIB M libname
; ===================
;
; An interactive mode to allow you to review and manipulate messages.
;
;
