; SPORTRTE Mail Routing Control File (Mail Routing)
; (C) 1988-1991, Augustine Associates
; SPORT Version 1.40
;
; THIS IS A SAMPLE CONTROL FILE FOR DEMONSTRATION PURPOSES ONLY;
;
; <- Semicolon denotes a comment line
;
;
; In order to have SPORT route your mail intelligently, you will need to
; use the Intelligent Router (SPORTRTE.EXE) and this control file.  Both
; files must be located in your SPORT default directory.
;
; This sample control file provides a basic explanation of the commands
; you can use to route mail.  Notice that comment lines begin with a
; semi-colon and will be ignored by SPORT.  All valid command lines
; must begin in column one.
;
;
; Different parts of this control file can be activated at different times
; of the day.  Normally the Intelligent Router will try to act on each valid
; command in this file if the keyword TIMESLOT is not found.  However, if
; the keyword TIMESLOT is located, the Router will only act on lines
; following the TIMESLOT command if the system time is within the START and
; END hour arguments.  For example, if you used this statement:
;
;TIMESLOT 06 12
;
; the Router would only process commands following this command if the system
; clock was between the hours of 06:00 and 12:00.  It is very important to
; note that this time restriction REMAINS IN EFFECT until a new restriction
; is encountered (a new TIMESLOT command).   Should you wish all commands
; to ALWAYS be processed use this:
;
;TIMESLOT 00 24
;
; If you do not use a TIMESLOT command it is possible that your commands
; will not be processed or possibly not processed in the proper sequence.
; To avoid this, we suggest you always use the example TIMESLOT command
; above as the first line in your control file.
;
;TIMESLOT 00 05
;Hold 521010
;TIMESLOT 06 12
;Route 521010
;TIMESLOT 13 24
;Hold 521010
;
;
; The most basic command for the Intelligent Router is the ROUTE command.
; It has several variations:
;
;ROUTE 521010
;ROUTE 521010 TO JOEBLOW
;ROUTE 521010 HOLD
;HOLD 521010 (same meaning as the command above)
;ROUTE 521010 TO JOEBLOW HOLD
;
; First a word of explanation about routing.  To ROUTE a Flash Message means
; to move it from your inbound area (where it was received) to your outbound
; area (the SPORT default area) AND do something to it.  That "something"
; can be as simple as move it along (ROUTE 521010), put it on hold for
; the calling node to pick up (ROUTE 521010 HOLD), route it through to a
; different node altogether (ROUTE 521010 TO JOEBLOW) or route it through
; to another node but put it on hold to be picked up when that node calls
; (ROUTE 521010 TO JOEBLOW HOLD).  The key to how to route the Flash Message
; is contained in how this command line is constructed.  Study the examples
; above for the correct line contstruction.
;
; Now that you have routed mail, suppose you want to keep a copy of the
; mail you are passing along.  This can be accomplised using the IMPORT
; keyword.  Let's assume that we want to route a Flash Message from
; 5210/10 to JOEBLOW but we also want to keep a copy of it in our own
; SFlash Libary.  Here is the command sequence:
;
;IMPORT 521010*.*
;ROUTE 521010 TO JOEBLOW
;
; Notice that the IMPORT command takes standard DOS arguments.  In this
; way you can specify a range of Flash Messages to import (keep copies of)
; as they are routed through your system.
;
; So far, these commands have all operated on inbound mail by putting that
; mail in your outbound area and modifying it as you direct.  The Router
; also allows you to manipulate mail waiting to be sent.  This gives you
; added flexibility in scheduling mail, especially when used with the
; TIMESLOT keyword.  There are two important commands to allow you to
; manage mail waiting to be sent:
;
;MARKHOLD [filename]
;MARKSEND [filename]
;
; Like the IMPORT command above, these two commands take DOS filename
; commands and wildcards.  For example, to mark all mail to nodes
; beginning with the character string "MIKE" as hold, do the following:
;
;MARKHOLD MIKE*.*
;
: To mark all mail to be held use:
;MARKHOLD *.*
;
; To mark all mail ready to send, use:
;
;MARKSEND *.*
;
; As you can see, using these two commands in conjunction with the keyword
; TIMESLOT, you can manage which mail is sent during specific times.
;
; Finally, you also have the capability to issue a DOS command directly
; from this control file.  To do so, use this keyword:
;
;DOS=[doscommand]
;
; Please notice that there are no spaces between the "DOS" and the commmand
; you wish to execute.  The ONLY valid seperator is an equal sign.  The
; format of this command must be exact and the DOS command must be a valid
; one for the Intelligent Router to process it.
;
;
; Now... it's time to construct your own control file...
;
;MARKHOLD *.*
