@echo off

rem  This batch file is used in TTYHOST, GDSTERM and $MENUCOM.UTL
rem  in order to set up for External Protocols such as Texas ZModem.
rem  The important part is that it have a DOWNLOAD section and and
rem  UPLOAD section.  Simply change the info in each section to whatever
rem  protocol you use requires.  Also, if you rename this file, make sure
rem  that you change the name in the .CFG files for TTYHOST,GDSTERM and
rem  $MENUCOM.CFG.   NOTE : See TXZM.DOC for info on locking the baud rate.
rem  ALSO, You MUST Define PROTOCOL?=PROTOCOL in your CFG file.  Make SURE
rem  that each program used matches the number used in this file.

rem           Example : PROTOCOL1=Texas ~Z~Modem
rem                                 ^ title on menu. '~'Z is HIGHLITED !!

rem  varibles output by GDSTERM, TTYHOST and $MENUCOM
rem  %1 = A WORD : ONE,TWO,THREE,FOUR,FIVE representing one of the five
rem       possible external protocols that you can use.
rem  %2 = THE WORD : UPLOAD OR DOWNLOAD
rem  %3 = PORT #
rem  %4 = CURRENT BAUD RATE
rem  %5 = CURRENT DOWNLOAD DIRECTORY ..  may not be needed but here it is.
rem  %6 = FILENAME STRING1 .. MAY CONTAIN SEVERAL FILES OR WILDCARDS
rem  %7 = FILENAME STRING2 .. MAY CONTAIN SEVERAL FILES OR WILDCARDS
rem  %8 = FILENAME STRING3 .. MAY CONTAIN SEVERAL FILES OR WILDCARDS
rem  %9 = FILENAME STRING4 .. MAY CONTAIN SEVERAL FILES OR WILDCARDS

IF "%1" == "" GOTO DONE                 ;protocol to use
IF "%2" == "" GOTO DONE                 ;upload or download
IF "%3" == "" GOTO DONE                 ;port #
IF "%2"=="UPLOAD" GOTO UPLOAD
IF "%2"=="DOWNLOAD" GOTO DOWNLOAD

GOTO DONE

:UPLOAD

 IF "%6" == "" GOTO DONE    ; check for filename to upload

 REM now we select one of the five protocols
 IF "%1" =="ONE" GOTO UP_ONE
 IF "%1" =="TWO" GOTO UP_TWO
 IF "%1" =="THREE" GOTO UP_THREE
 IF "%1" =="FOUR" GOTO UP_FOUR
 IF "%1" =="FIVE" GOTO UP_FIVE
 GOTO DONE

 : UP_ONE
   rem  insert upload commands for protocol #1
   txzm com%3 -l%4 -h -p -s %6 %7 %8 %9
   GOTO DONE
 : UP_TWO
   rem  insert upload commands for protocol #2
   hyperp PORT:2 HANDSHAKE:RTS/CTS COMPRESS:ON SEND %6 %7 %8 %9
   GOTO DONE
 : UP_THREE
   rem  insert upload commands for protocol #3
   rem  USE GDSOFT PROFX ZModem Send
   profx.exe /C %3 /B %4 /Z %6 %7 %8 %9
   GOTO DONE
 : UP_FOUR
   rem  insert upload commands for protocol #4
   rem  USE GDSOFT PROFX KERMIT Send
   profx.exe /C %3 /B %4 /F %6 %7 %8 %9
   GOTO DONE
 : UP_FIVE
   rem  insert upload commands for protocol #5
   GOTO DONE

:DOWNLOAD

 IF "%1" =="ONE" GOTO DN_ONE
 IF "%1" =="TWO" GOTO DN_TWO
 IF "%1" =="THREE" GOTO DN_THREE
 IF "%1" =="FOUR" GOTO DN_FOUR
 IF "%1" =="FIVE" GOTO DN_FIVE
 GOTO DONE

 : DN_ONE
   rem  insert download commands for protocol #1
   txzm com%3 -l%4 -h -e3 -r %5
   GOTO DONE
 : DN_TWO
   rem  insert download commands for protocol #2
   hyperp PORT:2 OVERWRITE:ON HANDSHAKE:RTS/CTS COMPRESS:ON RECEIVE
   GOTO DONE
 : DN_THREE
   rem  insert download commands for protocol #3
   rem  USE GDSOFT PROFX Zmodem Receive
   profx.exe /C %3 /B %4 /R /O /Z %6 %7 %8 %9
   GOTO DONE
 : DN_FOUR
   rem  insert download commands for protocol #4
   rem  USE GDSOFT PROFX KERMIT RECEIVE
   profx.exe /C %3 /B %4 /F /R %6 %7 %8 %9
   GOTO DONE
 : DN_FIVE
   rem  insert download commands for protocol #5
   GOTO DONE


:DONE
CANCEL              ; That's ALL Folks !!
