;͸
;                         WHOAMI.COM                             
;͵
; (c) Copyright 1994  Michael A. Jarvis.  All Rights Reserved.   
; Send questions or comments to:  mjarvis@okcforum.osrhe.edu     
;Ĵ
; Version 1.0                                  August 19, 1994   
; This program will return the NETBIOS network name of a         
; computer on a NetBIOS network.  If there is an error, it will  
; beep and display an error message.                             
;Ĵ
; Version 2.0                               September 13, 1994   
; The program was modified so that it trims off the trailing     
; blanks of the network name.  In version 1.0 the program ALWAYS 
; wrote 15 bytes to the screen.  Now if your network name is     
; something like TECH3, this program will only write 5 bytes.    
;
title 'Whoami.com'
.model TINY
.data
        NetName         db      15 dup(' '), '0'
        Inv_Fun         db      7,"Error:  Invalid Function"
        Inv_Len         equ     $ - Inv_Fun
        Counter         dw      1
        Space           db      ' '
.code
org 100h
Start:  mov     dx, offset NetName      ; Points to a 16-byte buffer to receive
                                        ; the zero-terminated network name.

        mov     ax, 5E00h               ; Function 5E00h -- Get Machine Name
        int     21h                     ; Execute Int 21h

        jc      Error                   ; If this function is unsuccessful,
                                        ; the carry flag is set and AX
                                        ; contains an error message.

        cmp     ch, 0                   ; If zero, then name not valid
        jz      Error

        mov     cx, 000Fh               ; Initialize pointer to 15 chars

TrimIt: call    ChkBlnk                 ; Is current char blank?
        je      AllDone                 ; If so we're done
        inc     Counter                 ; Otherwise, increment place holder
        loop    TrimIt                  ; Loop!

AllDone:mov     bx, 1                   ; Handle of screen
        mov     cx, Counter             ; Set CX to equal first non-blank.
                                        ; Note that CX now contains the
                                        ; location where the first blank
                                        ; space was found.  This will trim
                                        ; off the trailing blanks!

        mov     dx, offset NetName      ; Points to machine name
        mov     ah, 40h                 ; Write device
        int     21h

        jc      Error                   ; If carry flag is set, error!

        mov     ax, 4c00h               ; Function 4Ch -- End Program
        int     21h                     ; AL = 00 (Return Value)

Error:  mov     bx, 1                   ; File handle of screen
        mov     cx, Inv_Len             ; Number of bytes to write
        mov     dx, offset Inv_Fun      ; point to buffer containing message
        mov     ah, 40h                 ; Function 40h -- Write File or Device
        int     21h                     ; Execute Int 21h

        mov     ax, 4c01h               ; Function 4Ch -- End Program
        int     21h                     ; AL = 01 (Return Value)

ChkBlnk proc near
        push    cx                      ; Save the value of CX
        mov     si, offset Space        ; Space is simply a blank
        mov     di, offset NetName      ; Netname is the computer name
        add     di, Counter             ; Jump to the current character
        cmpsb                           ; Compare the strings
        pop     cx                      ; Restore CX
        ret                             ; Return
ChkBlnk endp
        end     Start
